      PROGRAM CCTEST
C
C   PROGRAM TO TEST THE CALCOMP LIBRARY ROUTINES
C
C                                       ED ANDERSON, NOAO, AUGUST 1985.
C
      CALL PLOTS(0.,0.,5)
      OPEN (UNIT=1, FILE='CCTEST.OUT', STATUS='NEW')
C............................................................TEST SCALE ROUTINES
      CALL TSCALE
      CALL TSYMBOL
      CALL TNUMBER
      CALL TANGLE
      CALL TAXIS
      CALL TCRAXES
      CALL TLINE
      CALL ENDPLOT
      CLOSE (UNIT=1)
      STOP 'OK'
      END
C*******************************************************************************
      SUBROUTINE TSCALE
      DIMENSION DATA(14)
      DATA DATA/0.5,1.,5.,10.,20.,40.,50.,80.,100.,250.,0.,0.,0.,0./
      WRITE (1,100) (DATA(I),I=1,10)
  100 FORMAT (' THIS SET OF 10 POINTS IS SCALED TO A 5-INCH AXIS',
     +        /3X,10F6.1//)
      CALL SCALE1(DATA,5.,10,1,0)
      WRITE (1,101) DATA(11),DATA(12)
  101 FORMAT (5X,'ROUTINE SCALE1 (LINEAR):  DATA(11)=AMIN=',F10.5,
     +       /5X,'                          DATA(12)=DA  =',F10.5)
      CALL SCALE1(DATA,5.,10,1,1)
      WRITE (1,102) DATA(11),DATA(12)
  102 FORMAT (5X,'ROUTINE SCALE1    (LOG):  DATA(11)=AMIN=',F10.5,
     +       /5X,'                          DATA(12)=DA  =',F10.5)
      CALL SCALE2(DATA,5.,10,1,0,AMIN0,DA0)
      WRITE (1,103) AMIN0,DA0
  103 FORMAT (5X,'ROUTINE SCALE2 (LINEAR):  DATA(11)=AMIN=',F10.5,
     +       /5X,'                          DATA(12)=DA  =',F10.5)
      CALL SCALE2(DATA,5.,10,1,1,AMIN1,DA1)
      WRITE (1,104) AMIN1,DA1
  104 FORMAT (5X,'ROUTINE SCALE2    (LOG):  DATA(11)=AMIN=',F10.5,
     +       /5X,'                          DATA(12)=DA  =',F10.5,
     +       //' ')
      WRITE (1,105)
  105 FORMAT (//' DATA WILL NOW BE TREATED AS PAIRED')
      CALL SCALE1(DATA,5.,5,2,0)
      CALL SCALE1(DATA(2),5.,5,2,0)
      WRITE (1,106) DATA(11),DATA(13),DATA(12),DATA(14)
  106 FORMAT (5X,'ROUTINE SCALE1 (LINEAR):  DATA(11)=1MIN=',F10.5,
     +       /5X,'                          DATA(13)=1DA =',F10.5,
     +       /5X,'                          DATA(12)=2MIN=',F10.5,
     +       /5X,'                          DATA(14)=2DA =',F10.5)
      CALL SCALE1(DATA,5.,5,2,1)
      CALL SCALE1(DATA(2),5.,5,2,1)
      WRITE (1,107) DATA(11),DATA(13),DATA(12),DATA(14)
  107 FORMAT (5X,'ROUTINE SCALE1    (LOG):  DATA(11)=1MIN=',F10.5,
     +       /5X,'                          DATA(13)=1DA =',F10.5,
     +       /5X,'                          DATA(12)=2MIN=',F10.5,
     +       /5X,'                          DATA(14)=2DA =',F10.5)
      CALL SCALE2(DATA,5.,5,2,0,AMIN1,DA1)
      CALL SCALE2(DATA(2),5.,5,2,0,AMIN2,DA2)
      WRITE (1,108) AMIN1,DA1,AMIN2,DA2
  108 FORMAT (5X,'ROUTINE SCALE2 (LINEAR):  DATA(11)=AMIN=',F10.5,
     +       /5X,'                          DATA(13)=1DA =',F10.5,
     +       /5X,'                          DATA(12)=2MIN=',F10.5,
     +       /5X,'                          DATA(14)=2DA =',F10.5)
      CALL SCALE2(DATA,5.,5,2,1,AMIN1,DA1)
      CALL SCALE2(DATA(2),5.,5,2,1,AMIN2,DA2)
      WRITE (1,109) AMIN1,DA1,AMIN2,DA2
  109 FORMAT (5X,'ROUTINE SCALE2    (LOG):  DATA(11)=AMIN=',F10.5,
     +       /5X,'                          DATA(13)=1DA =',F10.5,
     +       /5X,'                          DATA(12)=2MIN=',F10.5,
     +       /5X,'                          DATA(14)=2DA =',F10.5)
      DATA(2)=-DATA(2)
      DATA(4)=-DATA(4)
      DATA(8)=-DATA(8)
      WRITE (1,100) (DATA(I),I=1,10)
      CALL SCALE1(DATA,5.,10,1,0)
      WRITE (1,101) DATA(11),DATA(12)
      CALL SCALE2(DATA,5.,10,1,0,AMIN0,DA0)
      WRITE (1,103) AMIN0,DA0
      RETURN
      END
C*******************************************************************************
      SUBROUTINE TSYMBOL
CALIFORNIA COMPUTER PRODUCTS SYMBOL TABLE GENERATOR         V019
CALCOMP  PRODUCT NUMBER  411010*2-G              EBCDIC PUNCH
CALCOMP HCBS FOR CDC-6000     906/EM RS-232 ONLINE          JUL, 1979 *
CALCOMP  COPYRIGHT 1979 CALIFORNIA COMPUTER PRODUCTS INC.
C
C     THIS ROUTINE PRODUCES A SYMBOL TABLE, WHICH SHOWS THE CHARACTERS
C     AVAILABLE IN THE SYMBOL ROUTINE.
C
      CALL FACTOR(0.8)
      CALL PLOT(0.0,11.0,2)
      CALL PLOT (8.5,11.0,2)
      CALL PLOT (8.5,0.0,2)
      CALL PLOT (0.0,0.0,2)
      CALL SYMBOL(0.4,10.50,.2,'CHARACTERS AVAILABLE IN SYMBOL ROUTINE'
     1,0.0,38)
      CALL SYMBOL(0.4,10.25,.2,'FOR CALCOMP 1038 AND NOAO VAX COMPUTERS'
     1,0.0,39)
      CALL PLOT(8.1,10.0,3)
      CALL PLOT(0.4,10.0,2)
      CALL PLOT(0.4, 0.5,2)
      CALL PLOT(8.1, 0.5,2)
      Z=0.0
      M=0
      X=0.4
      Y=9.5
      XS=0.85
      YS=0.25
      DO 20 IA=1,7
      DO 10 IB=1,16
      CALL NUMBER(X+.1,Y+.18,.14,Z,0.0,-1)
      CALL SYMBOL(X+XS,Y+YS ,.4 ,M,0.0,-1)
      Z=Z+1.0
      M=M+1
 10   Y=Y-0.6
      X=X+1.1
      CALL PLOT(X,0.5,3)
      CALL PLOT(X,10.,2)
      Y=9.5
      XS=.65
      IO2=I1/8
 20   YS=.05
      CALL SYMBOL(0.6,.25,.12,'INTEGER FOR USE IN SYMBOL CALL SHOWN TO
     *LEFT OF EACH SYMBOL',0.0,60)
      CALL PLOT(10.0,0.0,-3)
      RETURN
      END
C*******************************************************************************
      SUBROUTINE TNUMBER
      DIMENSION ZNUM(4)
      DATA ZNUM /10293.84756,193.75,-204.86,-12345.6789/
      VAL=12.3456
      YPOS=5.0
C THE FOLLOWING TESTS THE NUMBER SUBROUTINE FOR PRECISION
      CALL SYMBOL(0.5,2.5,.20,'EXAMPLE OF NUMBER SUBROUTINE',90.0,28)
      Y=10.0
      DO 40 IA=1,4
      DO 30 IB=1,11
      CALL NUMBER(1.0,Y,.14,ZNUM(IA),0.0,IB-6)
 30   Y=Y-0.2
 40   Y=Y-0.3
      CALL SYMBOL(4.5,2.5,.20,'EXAMPLE OF NUMBER1 SUBROUTINE',90.0,29)
      Y=11.0
      DO 60 IB=1,11
      CALL NUMBER(6.0,Y,.14,ZNUM(1),0.0,IB-6)
      CALL NUMBER1(6.0,Y-0.2,.14,ZNUM(1),0.0,IB-6)
 60   Y=Y-0.4
      Y=6.0
      DO 70 IB=1,11
      CALL NUMBER(6.0,Y,.14,ZNUM(1),45.0,IB-6)
      CALL NUMBER1(6.0,Y-0.25,.14,ZNUM(1),45.0,IB-6)
 70   Y=Y-0.5
      CALL PLOT(8.0,0.0,-3)
      RETURN
      END
C*******************************************************************************
      SUBROUTINE TANGLE
      CALL PLOT(4.5,5.5,-3)                                             
      ANGLE=0.0                                                         
      HEIGHT=0.105                                                      
      DO 120  I=1,8                                                     
        RAD=0.0174533*ANGLE                                             
        XX=0.5*COS (RAD)                                                
        YY=0.5*SIN (RAD)                                                
        CALL SYMBOL( XX  , YY  ,HEIGHT,4HANG=,ANGLE, 4)                 
        CALL NUMBER(999.0,999.0,HEIGHT,ANGLE ,ANGLE,-1)                 
        CALL SYMBOL(999.0,999.0,HEIGHT,4H, H=,ANGLE, 4)                 
        CALL NUMBER(999.0,999.0,HEIGHT,HEIGHT,ANGLE, 3)                 
        HEIGHT=HEIGHT+0.035                                             
 120    ANGLE=ANGLE+45.0                                                
C      CALL NEWPEN(1)                                                    
      CALL SYMBOL(-1.4,4.0,0.14,19HANGULAR LETTER TEST,0.0,19)          
      CALL PLOT( 4.5, 5.0,3)                                            
      CALL PLOT(-4.5, 5.0,2)                                            
      CALL PLOT(-4.5,-5.5,2)                                            
      CALL PLOT( 4.5,-5.5,2)                                            
      CALL PLOT( 4.5, 5.0,2)                                            
      CALL PLOT( 6.5,-5.5,-3)                                           
      RETURN
      END
C*******************************************************************************
      SUBROUTINE TAXIS
      CHARACTER*24 TTL
      DIMENSION X(13),Y(13)
      TTL='TEST OF SUBROUTINE AXIS1'
      XX=-100.
      DO 1 I=1,11
         X(I)=XX
         Y(I)=XX**2
         IF (Y(I).EQ.0.) Y(I)=1.
         XX=XX+20.
    1 CONTINUE
      CALL SCALE2(X,10.,11,1,0,XMIN,XDA)
      CALL SCALE2(Y,8.,11,1,1,YMIN,YDA)
      X(12)=XMIN
      X(13)=XDA
      Y(12)=YMIN
      Y(13)=YDA
C
C.........................................................................X-AXIS
      CALL AXIS1(1.0,9.0,TTL, 24,10.,0.,XMIN,XDA,4,1.0,1)
      CALL AXIS1(1.0,7.5,TTL,-24,10.,0.,XMIN,XDA,2,2.0,1)
      CALL AXIS1(1.0,6.0,TTL, 24,10.,0.,XMIN,XDA,0,2.5,1)
      CALL AXIS1(1.0,4.5,TTL,-24,10.,0.,XMIN,XDA,-1,1.0,2)
      CALL AXIS1(1.0,2.0,1H         ,  1,10.,0.,XMIN,XDA,1,.5,3)
      CALL AXIS1(1.0,0.5,TTL,-24,10.,0.,XMIN,XDA,-1,0.0,2)
C
C..................................................... ...................Y-AXIS
      CALL AXIS1(12.0,0.,TTL, 24,8.,90.,YMIN,YDA,4,1.0,0)
      CALL AXIS1(13.5,0.,TTL,-24,8.,90.,YMIN,YDA,2,2.0,0)
      CALL AXIS1(15.0,0.,TTL, 24,8.,90.,YMIN,YDA,0,2.5,0)
      CALL AXIS1(16.5,0.,TTL,-24,8.,90.,YMIN,YDA,-1,1.0,0)
      CALL AXIS1(18.0,0.,1H         ,  1,8.,90.,YMIN,YDA,1,.5,0)
      CALL AXIS1(19.5,0.,TTL,-24,8.,90.,YMIN,YDA,-1,0.0,0)
C
C...............................................................AXIS ON AN ANGLE
      CALL AXIS1(21.0,0.,TTL, 24,10.,45.,XMIN,XDA,4,1.0,1)
      CALL AXIS1(22.5,0.,TTL, 24, 8.,45.,YMIN,YDA,4,1.0,0)
      CALL PLOT(29.,0.,-3)
C
C..................................................................NOW FOR AXIS2
      TTL='TEST OF SUBROUTINE AXIS2'
C
C.........................................................................X-AXIS
      CALL AXIS2(1.,9.,TTL,24,.25,.15,10.,0.,XMIN,XDA,2,1.0,1)
      CALL AXIS2(1.,7.,TTL,24,-.25,-.15,10.,0.,XMIN,XDA,2,2.0,1)
      CALL AXIS2(1.,5.,TTL,24,-.25,.15,10.,0.,XMIN,XDA,0,2.5,1)
      CALL AXIS2(1.,3.,TTL,24,.15,-.35,10.,0.,XMIN,XDA,-1,1.0,2)
      CALL AXIS2(1.,2.,1H       , 0,0.,.075,10.,0.,XMIN,XDA,1,.5,3)
      CALL AXIS2(1.,.5,TTL,24,-.25,0.,10.,0.,XMIN,XDA,-1,0.0,2)
C
C.........................................................................Y-AXIS
      CALL AXIS2(12.,0.,TTL,24,.25,.15,8.,90.,YMIN,YDA,4,1.0,0)
      CALL AXIS2(15.,0.,TTL,24,-.25,-.15,8.,90.,YMIN,YDA,2,2.0,0)
      CALL AXIS2(17.,0.,TTL,24,.25,-.15,8.,90.,YMIN,YDA,0,2.5,0)
      CALL AXIS2(19.,0.,TTL,24,.15,-.35,8.,90.,YMIN,YDA,-1,1.0,0)
      CALL AXIS2(21.,0.,1H       , 0,0.,0.075,8.,90.,YMIN,YDA,1,.5,0)
      CALL AXIS2(23.,0.,TTL,24,-.25,0.,8.,90.,YMIN,YDA,-1,0.0,0)
C
C...............................................................AXIS ON AN ANGLE
      CALL AXIS2(24.,0.,TTL,24,.25,.15,10.,45.,XMIN,XDA,2,1.0,1)
      CALL AXIS2(26.,0.,TTL,24,.25,.15, 8.,45.,YMIN,YDA,2,1.0,0)
      CALL PLOT(32.5,0.,-3)
      RETURN
      END
C*******************************************************************************
      SUBROUTINE TCRAXES
      CHARACTER*25 TTL
      DIMENSION X(13),Y(13)
      TTL='TEST OF SUBROUTINE CRAXES'
      XX=-10.
      DO 1 I=1,11
         X(I)=XX
         Y(I)=XX**3
         XX=XX+2.
    1 CONTINUE         
      X(12)=10.5
      Y(12)=10.5**3
      CALL SCALE2(X,10.,12,1,0,XMIN,XDA)
      CALL SCALE2(Y,8.,12,1,0,YMIN,YDA)
      CALL CRAXES(10.,8.,XMIN,XDA,YMIN,YDA,0,.15)
      CALL SYMBOL(1.91,10.0,.3,TTL,0.,25)
      CALL PLOT(11.,0.,-3)
      RETURN
      END
C*******************************************************************************
      SUBROUTINE TLINE
      CHARACTER*24 TTL
      DIMENSION X(13),Y(13), YY(13), XY(26)
      TTL='TEST OF SUBROUTINE LINE1'
      XX=0.
      DO 1 I=1,11
         X(I)=XX
         Y(I)=XX**2
         IF (Y(I).EQ.0.) Y(I)=1.
         XX=XX+20.
    1 CONTINUE
      CALL FACTOR(0.5)
C
C....................................................................LINEAR AXES
      CALL SCALE1(X,10.,11,1,0)
      CALL SCALE1(Y, 8.,11,1,0)
      CALL PLOT (1.0,1.0,-3)
      CALL AXIS1(0.,0.,1HX,-1,10., 0.,X(12),X(13),0,1.,1)
      CALL AXIS1(0.,0.,1HY, 1, 8.,90.,Y(12),Y(13),2,1.,1)
      CALL LINE1(X,Y,11,1,1,0,.15,0)
      CALL SYMBOL(2.43,8.1,0.25,TTL,0.,24)
C
C......................................................LOG Y-AXIS, LINEAR X-AXIS
      CALL PLOT(0.,10.,-3)
      CALL SCALE1(Y, 8.,11,1,1)
      CALL AXIS1(0.,0.,1HX,-1,10., 0.,X(12),X(13),0,1.,1)
      CALL AXIS1(0.,0.,6HLOG(Y), 6, 8.,90.,Y(12),Y(13),2,1.,0)
      CALL LINE1(X,Y,11,1,1,0,.15,1)
      CALL SYMBOL(2.43,8.1,0.25,TTL,0.,24)
C
C......................................................LINEAR Y-AXIS, LOG X-AXIS
      CALL PLOT(12.,-10.,-3)
      X(1)=1.
      Y(1)=1.
      CALL SCALE1(X,10.,11,1,1)
      CALL SCALE1(Y, 8.,11,1,0)
      CALL AXIS1(0.,0.,6HLOG(X),-6,10., 0.,X(12),X(13),0,1.,0)
      CALL AXIS1(0.,0.,1HY, 1, 8.,90.,Y(12),Y(13),2,1.,1)
      CALL LINE1(X,Y,11,1,1,0,.15,2)
      CALL SYMBOL(2.43,8.1,0.25,TTL,0.,24)
C
C.........................................................LOG Y-AXIS, LOG X-AXIS
      CALL PLOT(0.,10.,-3)
      CALL SCALE1(Y, 8.,11,1,1)
      CALL AXIS1(0.,0.,6HLOG(X),-6,10., 0.,X(12),X(13),0,1.,0)
      CALL AXIS1(0.,0.,6HLOG(Y), 6, 8.,90.,Y(12),Y(13),2,1.,0)
      CALL LINE1(X,Y,11,1,1,0,.15,3)
      CALL SYMBOL(2.43,8.1,0.25,TTL,0.,24)
C
C                              ****LINE2****
      TTL='TEST OF SUBROUTINE LINE2'
C
C....................................................................LINEAR AXES
      CALL PLOT (12.,-10.,-3)
      CALL SCALE2(X,10.,11,1,0,XMIN,XDA)
      CALL SCALE2(Y, 8.,11,1,0,YMIN,YDA)
      CALL AXIS1(0.,0.,1HX,-1,10., 0.,XMIN,XDA,0,1.,1)
      CALL AXIS1(0.,0.,1HY, 1, 8.,90.,YMIN,YDA,2,1.,1)
      CALL LINE2(X,XMIN,XDA,Y,YMIN,YDA,11,1,1,0,.15,0)
      CALL SYMBOL(2.43,8.1,0.25,TTL,0.,24)
C
C......................................................LOG Y-AXIS, LINEAR X-AXIS
      CALL PLOT(0.,10.,-3)
      CALL SCALE2(Y, 8.,11,1,1,YMIN,YDA)
      CALL AXIS1(0.,0.,1HX,-1,10., 0.,XMIN,XDA,0,1.,1)
      CALL AXIS1(0.,0.,6HLOG(Y), 6, 8.,90.,YMIN,YDA,2,1.,0)
      CALL LINE2(X,XMIN,XDA,Y,YMIN,YDA,11,1,1,0,.15,1)
      CALL SYMBOL(2.43,8.1,0.25,TTL,0.,24)
C
C......................................................LINEAR Y-AXIS, LOG X-AXIS
      CALL PLOT(12.,-10.,-3)
      X(1)=1.
      Y(1)=1.
      CALL SCALE2(X,10.,11,1,1,XMIN,XDA)
      CALL SCALE2(Y, 8.,11,1,0,YMIN,YDA)
      CALL AXIS1(0.,0.,6HLOG(X),-6,10., 0.,XMIN,XDA,0,1.,0)
      CALL AXIS1(0.,0.,1HY, 1, 8.,90.,YMIN,YDA,2,1.,1)
      CALL LINE2(X,XMIN,XDA,Y,YMIN,YDA,11,1,1,0,.15,2)
      CALL SYMBOL(2.43,8.1,0.25,TTL,0.,24)
C
C.........................................................LOG Y-AXIS, LOG X-AXIS
      CALL PLOT(0.,10.,-3)
      CALL SCALE2(Y, 8.,11,1,1,YMIN,YDA)
      CALL AXIS1(0.,0.,6HLOG(X),-6,10., 0.,XMIN,XDA,0,1.,0)
      CALL AXIS1(0.,0.,6HLOG(Y), 6, 8.,90.,YMIN,YDA,2,1.,0)
      CALL LINE2(X,XMIN,XDA,Y,YMIN,YDA,11,1,1,0,.15,3)
      CALL SYMBOL(2.43,8.1,0.25,TTL,0.,24)
C
C         ****NOW TEST LINE1 AND LINE2 FOR SYMBOLS AND SYMBOL SKIPPING****
C
      CALL PLOT(12.,-10.,-3)
      TTL='LINE1 SYMBOL TEST       '
      CALL SCALE1(X,10.,11,1,0)
      CALL SCALE1(Y, 8.,11,1,0)
      XMIN=X(12)
      XDA=X(13)
      YMIN=Y(12)
      YDA=Y(13)
      DO 2 I=1,13
         YY(I)=Y(I)
    2 CONTINUE
      CALL AXIS1(0.,0.,1HX,-1,10., 0.,X(12),X(13),0,1.,1)
      CALL AXIS1(0.,0.,1HY, 1,16.,90.,Y(12),Y(13),2,1.,1)
      DO 3 I=1, 15
         L=I-1
         IF (I.LE.7) THEN
            J=I-4
         ELSE
            J=1
         ENDIF
         CALL LINE1(X,YY,11,1,J,L,.15,0)
         DO 3 II=1, 11
            YY(II)=YY(II)+2500.
    3 CONTINUE
      CALL SYMBOL(2.43,16.1,0.25,TTL,0.,24)

      CALL PLOT (12.,0.,-3)
      DO 4 I=1,13
         YY(I)=Y(I)
    4 CONTINUE
      TTL='LINE2 SYMBOL TEST       '
      CALL SCALE2(X,10.,11,1,0,XMIN,XDA)
      CALL SCALE2(Y, 8.,11,1,0,YMIN,YDA)
      CALL AXIS1(0.,0.,1HX,-1,10., 0.,XMIN,XDA,0,1.,1)
      CALL AXIS1(0.,0.,1HY, 1,16.,90.,YMIN,YDA,2,1.,1)
      DO 5 I=1, 15
         L=I-1
         IF (I.LE.7) THEN
            J=I-4
         ELSE
            J=1
         ENDIF
         CALL LINE2(X,XMIN,XDA,YY,YMIN,YDA,11,1,J,L,.15,0)
         DO 5 II=1, 11
            YY(II)=YY(II)+2500.
    5 CONTINUE
      CALL SYMBOL(2.43,16.1,0.25,TTL,0.,24)
      CALL PLOT(12.,0.,-3)
C
C..................................................CHECK OUT REPEAT CYCLE ARRAYS
      TTL='LINE REPEAT CYCLE TEST  '
      J=0
      DO 6 I=1,25,2
         J=J+1
         XY(I)=X(J)
         XY(I+1)=Y(J)
    6 CONTINUE
      CALL SCALE1(XY,10.,11,2,0)
      CALL SCALE1(XY(2),8.,11,2,0)
      CALL SCALE2(XY,10.,11,2,0,XMIN,XDA)
      CALL SCALE2(XY(2),8.,11,2,0,YMIN,YDA)
      CALL AXIS1(0.,0.,1HX,-1,10., 0.,XMIN,XDA,0,1.,1)
      CALL AXIS1(0.,0.,1HY, 1, 8.,90.,YMIN,YDA,2,1.,1)
      CALL LINE1(XY,XY(2),11,2,1,0,0.2,0)
      DO 7 I=2,22,2
         XY(I)=XY(I)+5000.
    7 CONTINUE
      CALL LINE2(XY,XMIN,XDA,XY(2),YMIN,YDA,11,2,1,0,0.2,0)
      CALL SYMBOL(2.43,8.1,0.25,TTL,0.,24)
      RETURN
      END
