C     SUBROUTINE LINE2
C
C     PURPOSE
C        TO PLOT SET OF POINTS JOINED BY STRAIGHT LINES
C
C     USAGE
C        CALL LINE1(XARRAY,XMIN,XDA,YARRAY,YMIN,YDA,NPTS,K,J,L,HT,IC)
C           XARRAY - NAME OF ARRAY CONTAINING ABSCISSA OR X VALUES.
C           XMIN   - LOCATION OF THE FIRST XARRAY SCALE FACTOR
C           XDA    - LOCATION OF THE SECOND XARRAY SCALE FACTOR
C           YARRAY - NAME OF ARRAY CONTAINING ORDINATE OR Y VALUES.
C           YMIN   - LOCATION OF THE FIRST YARRAY SCALE FACTOR
C           YDA    - LOCATION OF THE SECOND YARRAY SCALE FACTOR
C           NPTS   - NUMBER OF POINTS TO BE PLOTTED
C           K      - REPEAT CYCLE OF A MIXED ARRAY
C           J      - |J|=0 NO SYMBOLS PLOTTED
C                    |J|=1 SYMBOL AT EVERY POINT
C                    |J|=2 SYMBOL AT EVERY SECOND POINT
C                          IF J<0 THEN NO LINE IS PLOTTED
C           L      - INTEGER VALUE OF THE SYMBOL TO BE PLOTTED
C           HT     - HEIGHT (INCHES) OF THE SYMBOL TO BE PLOTTED
C           IC     - = 0 IF X LINEAR, Y LINEAR
C                    = 1 IF X LINEAR, Y LOGARITHMIC
C                    = 2 IF X LOGARITHMIC, Y LINEAR
C                    = 3 IF X LOGARITHMIC, Y LOGARITHMIC
C
C     SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED
C        WHERE  - SUBROUTINE TO DETERMINE PEN POSITION
C        SYMBOL - SUBROUTINE TO PLOT A SYMBOL
C        PLOT   - SUBROUTINE TO MOVE THE PEN
C
C     COMMENTS
C        THIS PROGRAM WAS MODIFIED BY ED ANDERSON, JULY 1985.
C
CALCOMP  PRODUCT NUMBER  411010*2-G              EBCDIC PUNCH
CALCOMP HCBS FOR CDC 6000     906/EM RS-232 ONLINE          JUL, 1979 *
CALCOMP  COPYRIGHT 1979 CALIFORNIA COMPUTER PRODUCTS INC.
C
      SUBROUTINE LINE2(XARRAY,XMIN,XDA,YARRAY,YMIN,YDA,NPTS,K,J,L,HT,IC)
      DIMENSION XARRAY(1),YARRAY(1)
C
C................................................FIND ADDRESSES OF SCALE FACTORS
      FIRSTX = XMIN
      DELTAX = XDA
      FIRSTY = YMIN
      DELTAY = YDA
      NL=NPTS*K
C
C..........DETERMINE WHICH END OF THE LINE IS CLOSER TO THE PRESENT PEN POSITION
      CALL WHERE (XN,YN,FCTR)
      DF=AMAX1(ABS((XARRAY( 1)-FIRSTX)/DELTAX-XN),
     +         ABS((YARRAY( 1)-FIRSTY)/DELTAY-YN) )
      DL=AMAX1(ABS((XARRAY(NL)-FIRSTX)/DELTAX-XN),
     +         ABS((YARRAY(NL)-FIRSTY)/DELTAY-YN) )
      IF (DF.GT.DL) THEN
         IPNT=NL
         KK=-K
      ELSE
         IPNT=1
         KK=K
      ENDIF
C
C..................................................................PLOT THE LINE
      ISKIP=IABS(J)
      DO 1 I=1,NPTS
         IF (J.LT.0) THEN
            IPEN=3
            ICODE=-1
         ELSE IF (J.EQ.0) THEN
            IPEN=2
            ICODE=-1
         ELSE IF (J.GT.0) THEN
            IPEN=2
            ICODE=-2
         ENDIF
         IF (IC.EQ.0) THEN
            XPOS=(XARRAY(IPNT)-FIRSTX)/DELTAX
            YPOS=(YARRAY(IPNT)-FIRSTY)/DELTAY
         ELSE IF (IC.EQ.1) THEN
            XPOS=(XARRAY(IPNT)-FIRSTX)/DELTAX
            YPOS=(ALOG10(YARRAY(IPNT))-FIRSTY)*DELTAY
         ELSE IF (IC.EQ.2) THEN
            XPOS=(ALOG10(XARRAY(IPNT))-FIRSTX)*DELTAX
            YPOS=(YARRAY(IPNT)-FIRSTY)/DELTAY
         ELSE IF (IC.EQ.3) THEN
            XPOS=(ALOG10(XARRAY(IPNT))-FIRSTX)*DELTAX
            YPOS=(ALOG10(YARRAY(IPNT)-FIRSTY))*DELTAY
         ENDIF
         IF (I.EQ.1) THEN
            IIPEN=3
            IICODE=-1
         ELSE
            IIPEN=IPEN
            IICODE=ICODE
         ENDIF
         IF (ISKIP.NE.0) THEN
            IF (MOD((I+ISKIP-1),ISKIP).EQ.0) THEN
               CALL SYMBOL(XPOS,YPOS,HT,L,0.,IICODE)
            ELSE
               CALL PLOT(XPOS,YPOS,IIPEN)
            ENDIF
         ELSE
            CALL PLOT(XPOS,YPOS,IIPEN)
         ENDIF
         IPNT=IPNT+KK
    1 CONTINUE
      RETURN
      END
