#{ Package script task for the NLOCAL package.  Add task declarations here
# for any locally added tasks or subpackages.

#images
#dataio
softools
#noao
artdata

cl < "nlocal$lib/zzsetenv.def"
package nlocal, bin=nlocalbin$

# Define external packages - this isn't quite the same usage as the
# core system - pkg defs and help aren't available until nlocal is loaded.
if (access ("nlocal$lib/extern.pkg"))
    cl  < "nlocal$lib/extern.pkg"

# CL scripts

# task	archive		= "nlocal$src/archive.cl"	; hidetask archive
task	bases		= "nlocal$src/bases.cl"
task	chnode		= "nlocal$src/chnode.cl"
task	errmsg		= "nlocal$src/errmsg.cl"
task	findfits	= "nlocal$src/findfits.cl"
task	findshutcorr	= "nlocal$src/findshutcorr.cl"
task	hash		= "nlocal$src/hash.cl"
task	$matrix		= "nlocal$src/matrix.cl"
task	orphan		= "nlocal$src/orphan.cl"
task	qdisplay	= "nlocal$src/qdisplay.cl"
task	qhdisplay	= "nlocal$src/qhdisplay.cl"
task	quad		= "nlocal$src/quad.cl"
task	squad		= "nlocal$src/squad.cl"
task	queue		= "nlocal$src/queue.cl"
task	resize		= "nlocal$src/resize.cl"
task	shiftlist	= "nlocal$src/shiftlist.cl"
task	sunsetup	= "nlocal$src/sunsetup.cl"
task	wdisplay	= "nlocal$src/wdisplay.cl"

# Subpackages

task	calcomp		= "nlocal$src/calcomp/x_calcomp.e"
task	longplot	= "nlocal$src/longplot/x_longplot.e"
# task	waveplot	= "nlocal$src/longplot/waveplot.cl"


# IMFORT and host programs:

task	$splist		= ("$" // osfn ("nlocalbin$splist.e") // " $(*)")

# SPP tasks:

task	bitcount,
	bswap,
	getpds,
	lcode,
	linenum,
	lutreplace,
	pairmass,
	paste,
	pavg,
	pixfix,
	pixheader,
	pixupdate,
	radlist,
	ranges,
	rccd,
	signfix,
	specfocus,
	sun2iraf,
	surfview = "nlocal$src/x_nlocal.e"

clbye()
