/* Subroutine to be linked with calcomp stuff to write out a file
 * of Calcomp commands to be queued for later plotting on Carina.
 *
 * Sept 85:  Also include are routines which provide the user-name and
 *           date of plot creation. era
 *
 * Sept 85:  Also included is the routine to print error messages.
 *
 * The above two mods were requested by D. Tody so that IRAF would not have
 * to include the U77 library in its compile.
 */

#include <stdio.h>
#include <signal.h>
#include <sys/file.h>

#ifdef	DEBUG
char	picture[] = "./xxxxxxxCcAXXXXXX";
#else
char	picture[] = "/usr/tmp/ccAXXXXXX";
#endif
int	run = 11;		/* index of 'A' in picture[] */

int	ccwfd = -1 ;	/* File descriptor to write on.  It is also
			 * used as a flag; negative means never opened,
			 * 0 means not currently open, positive means
			 * open now.
			 */

cwritr_( n, s )		/* Write Calcomp byte stream. */
int	*n ;
char	*s ;
{
	extern int cleanup();

	if( ccwfd <= 0 ) {
		if( ccwfd < 0 ) {
			signal(SIGTERM, cleanup);
			if (signal(SIGINT, SIG_IGN) != SIG_IGN)
				signal(SIGINT, cleanup);
			mktemp( picture ) ;
		}
		if( ( ccwfd = open( picture, O_WRONLY|O_CREAT|O_EXCL, 0666 ) )
				< 0 ) {
			fprintf(stderr, "cwritr: cannot create %s\n", picture);
			cleanup();
		}
	}

	/* Write character count for command, then command string. */

#ifdef	sun
	{
		char	char_n = (char)*n ;
		write( ccwfd, &char_n, 1 ) ;
	}
#else		sun
	write( ccwfd, n, 1 ) ;
#endif	sun
	write( ccwfd, s, *n ) ;

}

cwritc_()		/* Close out file on normal exit and queue it. */
{
	char	sys_string[120] ;

	if( ccwfd <= 0 )
		return ;

	close(ccwfd) ;
	ccwfd = 0 ;
	sprintf( sys_string, "/usr/ucb/lpr -Pcalcomp -v -s -r -J cclib %s\0",
		picture ) ;
#ifndef DEBUG
	system( sys_string ) ;
#else
	fprintf( stderr, "sys_string: %s\n", sys_string ) ;
#endif
	picture[run]++;
}

cleanup()		/* Error Exit */
{
	if( ccwfd > 0 )
		unlink( picture ) ;
       	exit(1);
}

char *getlogin();               /* Pirated GETLOG routine from U77 library*/
getlog_(name, len)
char *name; long len;
{
	char *l = getlogin();

	bchar(l?l:" ", name, len);
}


fdate_(s, strlen)        /* Pirated FDATE routine from U77 library*/
char *s; long strlen;
{
	char *ctime(), *c;
	long time(), t;

	t = time(0);
	c = ctime(&t);
	c[24] = '\0';
	bchar(c, s, strlen);
}

bchar(from, to, tolen)
char *from, *to;
long tolen;

{	int i=0;
	while (*from && i < tolen) {
		*to++ = *from++;
		i++;
	}
	while (i++ < tolen)
		*to++ = ' ';
}

err_(s)                 /* Routine to print error messages*/
char *s;
{
	printf("%s\n",s);
}
