/* Subroutine to be linked with calcomp stuff to write out a file
 * of calcomp commands suitable for transfer over the Ethernet
 * for plotting from a Unix machine
 */

#include <stdio.h>
#include <signal.h>
#include <perror.h>

#define BUFSIZE	512

char	picture[] = "ccplot.plt";

int	ccwfd = -1 ;	/* File descriptor to write on.  It is also
			 * used as a flag; negative means never opened,
			 * 0 means not currently open, positive means
			 * open now.
			 */

	char buf[BUFSIZE];	/* internal buffer */
	char *bufptr;	/* pointer to last spot used in buf */

cwritr( n, s )		/* Write Calcomp byte stream. */
int	*n ;
char	*s ;
{
	extern int cleanup();
	char *sptr;
	int i;

	sptr = s;

	if( ccwfd <= 0 ) {
		if( ccwfd < 0 ) {
			signal(SIGTERM, cleanup);
			if (signal(SIGINT, SIG_IGN) != SIG_IGN)
				signal(SIGINT, cleanup);
		}
		if((ccwfd=creat(picture,0,"mrs=512","rfm=fix")) < 0 ) {
			perror("cwritr");
			fprintf(stderr, "cwritr: cannot create %s\n", picture);
			cleanup();
		}
		bufptr = buf;
                chmod(picture,0777);
	}

	/* Put in character count for command */

	*bufptr++ = *n;

	if (bufptr >= &buf[BUFSIZE]) {
		if (write (ccwfd, buf, BUFSIZE) < 0) {
	           perror("cwritr -- cannot write to file\n") ;
        	   cleanup();
		}
		bufptr = buf;
	}

	/* Put in rest of command */

	for (i = *n; i>0; i--) {

		*bufptr++ = *sptr++;

		if (bufptr >= &buf[BUFSIZE]) {
			if (write (ccwfd, buf, BUFSIZE) < 0) {
	        	  	perror("cwritr -- cannot write to file\n") ;
        			cleanup();
			}
			bufptr = buf;
		}
	}


}

cwritc( )		/* Close out file on normal exit */
{
	if( ccwfd <= 0 )
		return ;

	for ( ; bufptr < &buf[BUFSIZE]; bufptr++)
		*bufptr = 0;

	if (write (ccwfd, buf, BUFSIZE) < 0) {
           perror("cwritr -- cannot write to file\n") ;
       	   cleanup();
	}
	close(ccwfd) ;
	ccwfd = 0 ;
}

cleanup()		/* Error Exit */
{
	if( ccwfd > 0 )
       	exit(1);
}
