procedure findfits (fits_files, newtape, review)

string	rootdir		= "."	{prompt="Root directory of tree to be FITSed"}
string	extn		= ".imh" {prompt="Image extension(s) to be FITSed\n"}

string	fits_files		{prompt="FITS filename"}
bool	newtape			{prompt="Blank tape?"}

real	bscale		= 1.	{prompt="FITS bscale"}
real	bzero		= 0.	{prompt="FITS bzero"}

bool	make_image	= yes	{prompt="Create a FITS image?"}
bool	long_header	= no	{prompt="Print FITS header cards?"}
bool	short_header	= yes	{prompt="Print short header?"}

int	bitpix		= 0	{prompt="FITS bits per pixel"}
int	blocking_factor	= 1	{prompt="FITS tape blocking factor"}

bool	scale		= yes	{prompt="Scale data?"}
bool	autoscale	= yes	{prompt="Auto_scaling?"}

bool	review		= no	{prompt="Review the list of image headers?"}

begin
	string	l_fits_files, tmp1, tmp2, tmp3
	bool	l_newtape

	cache ("orphan")

	tmp1 = mktemp ("tmp$tmp")
	tmp2 = mktemp ("tmp$tmp")
	tmp3 = mktemp ("tmp$tmp")

	l_fits_files = fits_files
	l_newtape = newtape

	print ("Searching the directory tree...")
	rmfiles ("-nv", rootdir, "-only", extn, > tmp1)
	match ("..", tmp1, stop+, meta-, > tmp2)
	delete (tmp1, ver-, >& "dev$null")

	orphan ("@" // tmp2, stop+, > tmp1)

	if (review) {
	    page (tmp1)

	    if (orphan.number > 0) {
		print ("LIST OF ORPHANED HEADERS", > tmp3)
		print ("========================\n", >> tmp3)
		print ("(These will NOT be archived to tape!)\n", >> tmp3)
		orphan ("@" // tmp2, >> tmp3)
		page (tmp3)
		delete (tmp3, ver-, >& "dev$null")
	    }

	    delete (tmp2, ver-, >& "dev$null")
	}

	wfits ("@" // tmp1, fits_files=l_fits_files, newtape=l_newtape,
	    bscale=bscale, bzero=bzero, make_image=make_image,
	    long_header=long_header, short_header=short_header,
	    bitpix=bitpix, blocking_factor=blocking_factor,
	    scale=scale, autoscale=autoscale)

	delete (tmp1, ver-, >& "dev$null")
end
