include	<mach.h>
include	"lblglabax.h"

# LBL_ENCODE -- Encode a floating point number as a character string for a
# tick label.  Taken almost entirely from gio$glabax/glbencode.x (which see)
# with only minor modifications, one of which is to return the number of
# characters encoded.

int procedure lbl_encode (x, out, maxch, format, step)

real	x			# number to be encoded
char	out[ARB]		# output string
int	maxch			# max chars out
char	format[ARB]		# sprintf format
real	step			# tick spacing

int	ip, op
real	nicex

begin
	# Test for the zero tick, to avoid tick labels that look like the
	# machine epsilon.

	if (abs (x / step) < TOL)
	    nicex = 0
	else
	    nicex = x

	# Encode number.
	call sprintf (out, maxch, format)
	    call pargr (nicex)

	# Lop off any insignificant trailing zeros or periods.
	for (ip=1;  out[ip] != EOS;  ip=ip+1)
	    ;
	ip = ip - 1

	while (ip > 1 && out[ip] == '0')
	    ip = ip - 1
	if (ip > 1 && out[ip] == '.')
	    ip = ip - 1
	if (ip >= 1)
	    out[ip+1] = EOS

	# Lop off any insignificant leading zeros, but be sure to leave at
	# least one digit.

	for (op=1;  out[op] == '-' || out[op] == '+';  op=op+1)
	    ;
	for (ip=op;  out[ip] == '0' && out[ip+1] != EOS;  ip=ip+1)
	    ;
	while (out[ip] != EOS) {
	    out[op] = out[ip]
	    op = op + 1
	    ip = ip + 1
	}
	out[op] = EOS

	return (op-1)
end
