include	<gio.h>
include "lpl.h"

# LBL_SETUP -- Set up the axis drawing and labelling parameters.  This 
# routine is almost entirely taken from gio$glabax/glbsetup.x, but with
# a few exceptions for the LONGPLOT environment (as noted).  These are
# the coordinate transformations, i.e., log scaling, window and viewport
# coordinates, plus the parameters which pertain only to axis drawing and
# labelling.  The order in which the subprocedures are called is significant.

procedure lbl_setup (gp, axes, ntitlelines, xlabel, ylabel)

pointer	gp			# graphics descriptor
pointer	axes[4]			# array of pointers to axis descriptors
int	ntitlelines		# number of lines in title block
char	xlabel[ARB]		# x axis label
char	ylabel[ARB]		# y axis label

#debug+
int	debug
common /deb/ debug
#debug-
begin
	# If log scaling is in effect on either axis, verify that log scaling
	# is sensible and if so select either LOG or ELOG scaling.

	call lbl_verify_log_scaling (gp)

	# Find the best positions for the tick marks (unlike glb_find_ticks,
	# this routine does not extend the WCS as that was already done in
	# lpl_wcs_extend()).

	call lbl_find_ticks (gp, XCOORD, axes[1], axes[4])
	call lbl_find_ticks (gp, YCOORD, axes[3], axes[2])

	# Set the remaining parameters in the axis drawing descriptors.
	# Must not be called until the window and viewport coordinates are
	# fixed.

	call lbl_set_axes (gp, XCOORD, axes[1], axes[4])
	call lbl_set_axes (gp, YCOORD, axes[3], axes[2])
end
