include	<mach.h>
include	<gset.h>
include	<gio.h>
include	"lblglabax.h"

# LBL_PLOT_TITLE -- Draw plot title block.  Taken almost entirely from
# gio$glabax/glbtitle.x (which see), with only minor modifications.

procedure lbl_plot_title (gp, title, ntitlelines)

pointer	gp			# graphics descriptor
char	title[ARB]		# title block
int	ntitlelines		# number of lines in title block

int	lineno, ip, wcs, titlejust
real	char_height, x, y, dy, vxmin,vxmax, vymin,vymax
real	titlesize
pointer sp, op, lbuf, format

int	gstati()
real	ggetr(), gstatr()

#debug+
int	debug
common /deb/ debug
#debug-
begin
	if (title[1] == EOS || ntitlelines < 1)
	    return

	call smark (sp)
	call salloc (lbuf, SZ_LINE, TY_CHAR)
	call salloc (format, SZ_FORMAT, TY_CHAR)

	titlesize = gstatr (gp, G_TITLESIZE)
				#temporary bug fix; gstat dies on titlejust
	titlejust = GT_CENTER	#gstati (gp, G_TITLEJUST)

	char_height = ggetr (gp, "ch")
	if (char_height < EPSILON)
	    char_height = DEF_CHARHEIGHT * titlesize

	wcs = gstati (gp, G_WCS)
	call ggview (gp, vxmin,vxmax, vymin,vymax)

	y = min (1.0 - char_height,
	    vymax + (ntitlelines - 1 + 0.5) * char_height)

	call sprintf (Memc[format], SZ_FORMAT, "hj=%c,vj=b")
	    switch (titlejust) {
	    case GT_LEFT:
		call pargi ('l')
		x = vxmin
	    case GT_RIGHT:
		call pargi ('r')
		x = vxmax
	    default:
		call pargi ('c')
		x = (vxmin + vxmax) / 2.0
	    }

	call gsetr (gp, G_TXSIZE, titlesize)
	call gseti (gp, G_WCS, 0)
	lineno = 1
	op = lbuf

	for (ip=1;  title[ip] != EOS;  ip=ip+1)
	    if (title[ip] == '\n' || (title[ip+1] == EOS && op > lbuf)) {
		if (title[ip] != '\n') {
		    Memc[op] = title[ip]
		    op = op + 1
		}
		Memc[op] = EOS
		dy = (lineno - 1) * char_height
		call gtext (gp, x, y - dy, Memc[lbuf], Memc[format])
		lineno = lineno + 1
		op = lbuf
	    } else {
		Memc[op] = title[ip]
		op = op + 1
	    }
	
	call sfree (sp)
end
