# LONGPLOT global definitions

define	DEF_MAJRX	5	# Default major ticks in x
define	DEF_MAJRY	5	# Default major ticks in y
define	DEF_PXMIN	0.0	# Default minimum x-position in plotter units
define	DEF_PXMAX	10.0	# Default maximum x-position in plotter units
define	DEF_PYMIN	0.0	# Default minimum y-position in plotter units
define	DEF_PYMAX	8.0	# Default maximum height in plotter units
define	INCHES_TO_CM	2.54	# Conversion factor for punits=cm rather than in
define	IMAGE_INPUT	1	# Input data is an image
define	LIST_INPUT	2	# Input data is a list
define	MAX_CURVES	50	# Maximum curves that can be plotted in one run
define	MAX_SCALEWORDS	20	# Maximum chars in a scale to pass to gescape
define	MAXWORDSIZE	50	# Maximum chars in string input parameters
define	MULT_OVERTRACE	1	# Plot multiple curves overtraced on one another
define	MULT_SERIES	2	# Plot multiple curves in series
define	MULT_STACK	3	# Plot multiple curves with full vertical offset
define	MULT_STACK_DY	4	# Plot multiple curves with delta-y offset
define	NUM_GIO_LTYPE	4	# Number of distinct linetypes to loop over
define	NUM_GIO_MARKER	9	# Number of distinct markercodes to loop over
define	PLOT_BOTH	1	# Plot both lines and marker symbols
define	PLOT_LINE	2	# Plot only lines
define	PLOT_MARK	3	# Plot only marker symbols
define	POS_ABOVE	1	# Title position above rest of plot
define	POS_BELOW	2	# Title position below rest of plot
define	POS_LEGEND	3	# Title located at legend position
define	SYN_TO_1	','	# Syntactical "to" separator for coord params
define	SYN_TO_2	'/'	# Alternate
define	SYN_PLUS_1	'&'	# Syntactical "range" separator for coord params
define	SYN_PLUS_2	'%'	# Alternate
define	SZ_BUF		2048	# Initial and incremental buffer size
define	UNIT_INCH	1	# Reference plot-unit parameter units are inches
define	UNIT_CM		2	# Reference plot-unit parameter units are cm
define	XCOORD		1	# x coordinate 
define	YCOORD		2	# y coordinate


# The LONGPLOT structure.

define	LEN_LPL			(70)

define	LPL_AXIS		Memi[$1]	# Image projection axis
define	LPL_DBOLD		Memi[$1+1]	# Bold Data lines/markers?
define	LPL_DIFFERENTIATE	Memi[$1+2]	# Different line/markertypes?
define	LPL_FLOATCHARSIZE	Memi[$1+3]	# Scale char sizes with plot?
define	LPL_GRID		Memi[$1+4]	# Draw grid lines?
define	LPL_INBUF		Memi[$1+5]	# Input specification pointer
define	LPL_LBOLD		Memi[$1+6]	# Bold Labels, axes, ticks?
define	LPL_LEGEND		Memi[$1+7]	# Draw a legend?
define	LPL_MAJRX		Memi[$1+8]	# No. of major ticks in x
define	LPL_MAJRX_INDEF		Memi[$1+9]	# Holder for original specif.
define	LPL_MAJRY		Memi[$1+10]	# No. of major ticks in y
define	LPL_MAJRY_INDEF		Memi[$1+11]	# Holder for original specif.
define	LPL_MARKERSIZE		Memr[P2R($1+12)]# Marker size, charsize units
define	LPL_MARKERTYPE		Memi[$1+13]	# Marker type as power of 2
define	LPL_MINRX		Memi[$1+14]	# No. of minor ticks in x
define	LPL_MINRY		Memi[$1+15]	# No. of minor ticks in y
define	LPL_MULTIPLE		Memi[$1+16]	# Multiple plot placement
define	LPL_ONE_X_ONLY		Memi[$1+17]	# Draw 1 x-axis only?
define	LPL_PLOTMODE		Memi[$1+18]	# Plot lines, markers, or both
define	LPL_PXMIN		Memr[P2R($1+19)]# Plotter-unit minimum in x
define	LPL_PXMIN_INDEF		Memi[$1+20]	# Holder for original specif.
define	LPL_PXMAX		Memr[P2R($1+21)]# Plotter-unit maximum in x
define	LPL_PXMAX_INDEF		Memi[$1+22]	# Holder for original specif.
define	LPL_PYMIN		Memr[P2R($1+23)]# Plotter-unit minimum in y
define	LPL_PYMIN_INDEF		Memi[$1+24]	# Holder for original specif.
define	LPL_PYMAX		Memr[P2R($1+25)]# Plotter-unit maximum in y
define	LPL_PYMAX_INDEF		Memi[$1+26]	# Holder for original specif.
define	LPL_ROTATE		Memi[$1+27]	# Rotate entire plot 90 degrees?
define	LPL_SCALEBAR		Memi[$1+28]	# Draw a scale bar?
define	LPL_TICKLABEL		Memi[$1+29]	# Label tick marks?
define	LPL_TITLE		Memi[$1+30]	# Title specification pointer
define	LPL_TITLENDX		Memi[$1+31]	# Pointer to individual titles
define	LPL_TITLEPOS		Memi[$1+32]	# Position of title block
define	LPL_UNIT_SCALE		Memr[P2R($1+33)]# Plotter unit conversion factor
define	LPL_WXMIN		Memr[P2R($1+34)]# World x minimum
define	LPL_WXMIN_INDEF		Memi[$1+35]	# Holder for original specif.
define	LPL_WXMAX		Memr[P2R($1+36)]# World x maximum
define	LPL_WXMAX_INDEF		Memi[$1+37]	# Holder for original specif.
define	LPL_WYMIN		Memr[P2R($1+38)]# World y minimum
define	LPL_WYMIN_INDEF		Memi[$1+39]	# Holder for original specif.
define	LPL_WYMAX		Memr[P2R($1+40)]# World y maximum
define	LPL_WYMAX_INDEF		Memi[$1+41]	# Holder for original specif.
define	LPL_XAUTOEXPAND		Memi[$1+42]	# Auto-expand world x ranges?
define	LPL_XLABEL		Memi[$1+43]	# X-axis label pointer
define	LPL_XLOGLIN		Memi[$1+44]	# X-axis transform log or linear
define	LPL_XROUND		Memi[$1+45]	# Round world x ranges?
define	LPL_XSCALE		Memr[P2R($1+46)]# World x / plotter x scale
define	LPL_XSCALE_INDEF	Memi[$1+47]	# Holder for original specif.
define	LPL_XTRAN		Memi[$1+48]	# Is there an X-axis transform?
define	LPL_XTRSTR		Memi[$1+49]	# X-axis transform string ptr
define	LPL_YAUTOEXPAND		Memi[$1+50]	# Auto-expand world y axis?
define	LPL_YDELTA		Memr[P2R($1+51)]# Delta-y for stacked plots
define	LPL_YLABEL		Memi[$1+52]	# Y-axis label pointer
define	LPL_YLOGLIN		Memi[$1+53]	# Y-axis transform log or linear
define	LPL_YROUND		Memi[$1+54]	# Round world y ranges?
define	LPL_YSCALE		Memr[P2R($1+55)]# World y / plotter y scale
define	LPL_YSCALE_INDEF	Memi[$1+56]	# Holder for original specif.
define	LPL_YTRAN		Memi[$1+57]	# Is there a Y-axis transform?
define	LPL_YTRSTR		Memi[$1+58]	# Y-axis transform string ptr
				# extra space


# dynamically allocated string buffers only pointed to by this structure
define	INBUF			Memc[$1+$2]
define	TITLE			Memc[$1+$2]
define	XLABEL			Memc[$1]
define	YLABEL			Memc[$1]
