include <ctotok.h>
include <ctype.h>
include "lpl.h"

define	MKRWORDSIZE	7	# Max size of a marker word ("diamond")

# LPL_CNV_MARKER -- Convert list of character marker symbol specifications
# into gio marker code.

int procedure lpl_cnv_marker (markerspec)

char	markerspec[ARB]

int	ip, gio_code, token, ndx, pow2
char	word[MKRWORDSIZE], extracted_word[MKRWORDSIZE]

int	ctotok(), strdic(), or()
bool	strne()

string	msym "|point|fill|box|plus|cross|diamond|hline|vline|hebar|vebar|circle"

begin
	# Pull successive marker symbol names from list until end of list,
	# OR'ing them together after translating; list element separators
	# are anything other than (identifier, [_$.*]), and need not appear
	# as the first character.

	for (ip = 1;  IS_WHITE(markerspec[ip]);  ip = ip + 1)
	    ;
	gio_code = 0
	if (strne (markerspec, "*"))
	    repeat {
		token = ctotok (markerspec, ip, word, MKRWORDSIZE)
		if (token == TOK_IDENTIFIER) {
		    ndx = strdic (word, extracted_word, MKRWORDSIZE, msym)
		    if (ndx > 0) {
			pow2 = 2 ** (ndx - 2)
			gio_code = or (gio_code, pow2)
		    } else {
			call eprintf (
			    "WARNING (LPL_CNV_MARKER) bad marker specif. %s\n")
			    call pargstr (extracted_word)
			call eprintf ("    Marker type reset to `point'\n")
		    }
		}
	    } until (token == TOK_EOS)

	return (gio_code)
end
