include <gset.h>
include "lpl.h"
include "lpx.h"

# LPL_DRAWDATA -- Draw a single data curve.

procedure lpl_drawdata (lpl, lpx, gd, x, y, nelems, curve)

pointer	lpl		# longplot descriptor
pointer	lpx		# per-curve arrays
pointer	gd		# graphics device descriptor
real	x[ARB],y[ARB]	# data array
int	nelems		# number of points in current curve
int	curve		# current curve index for gpmark (... marktype[])

#debug+
int	debug
common /deb/ debug
real	xx_1,xx_2, yy_1,yy_2
#debug-
begin

#debug+
if (debug == YES) {
call eprintf ("$#*--> in lpl_drawdata, x[1] = %g, y[1] = %g, nelems = %d\n")
call pargr (x[1]); call pargr (y[1]); call pargi (nelems)
call eprintf ("                        x[%d]= %g, y[%d]= %g\n")
call pargi (nelems/2); call pargr (x[nelems/2]); call pargi (nelems/2)
call pargr (y[nelems/2])
call eprintf ("                        x[%d]= %g, y[%d]= %g\n")
call pargi (nelems); call pargr (x[nelems]); call pargi (nelems)
call pargr (y[nelems])
call ggwind (gd, xx_1,xx_2, yy_1,yy_2)
call eprintf ("                ggwind, x1=%g, x2=%g, y1=%g, y2=%g\n")
call pargr (xx_1); call pargr (xx_2); call pargr (yy_1); call pargr (yy_2)
}
#debug-
	# We plot a polyline, polymarker, or both.
	if (LPL_PLOTMODE(lpl) != PLOT_MARK)
	    call gpline (gd, x, y, nelems)

	if (LPL_PLOTMODE(lpl) != PLOT_LINE)
	    call gpmark (gd, x, y, nelems, LPX_MARKERTYPE(lpx,curve-1),
		LPX_MARKERSIZE(lpx,curve-1), LPX_MARKERSIZE(lpx,curve-1))
end
