include "lpx.h"

# LPL_FREE_LPX -- Free memory for the per-curve arrays governing sizes, scales,
# line/marker types etc.

procedure lpl_free_lpx (lpx)

pointer	lpx		# per-curve arrays descriptor

begin
	# Free the dynamically-allocated memory for the per-curve arrays.

	call mfree (LPMEM_LINETYPE(lpx), TY_INT)
	call mfree (LPMEM_MAJRX(lpx), TY_INT)
	call mfree (LPMEM_MAJRY(lpx), TY_INT)
	call mfree (LPMEM_MARKERSIZE(lpx), TY_REAL)
	call mfree (LPMEM_MARKERTYPE(lpx), TY_INT)
	call mfree (LPMEM_MINRX(lpx), TY_INT)
	call mfree (LPMEM_MINRY(lpx), TY_INT)
	call mfree (LPMEM_PXMIN(lpx), TY_REAL)
	call mfree (LPMEM_PXMAX(lpx), TY_REAL)
	call mfree (LPMEM_PXSCALE(lpx), TY_REAL)
	call mfree (LPMEM_PYMIN(lpx), TY_REAL)
	call mfree (LPMEM_PYMAX(lpx), TY_REAL)
	call mfree (LPMEM_PYSCALE(lpx), TY_REAL)
	call mfree (LPMEM_WXMIN(lpx), TY_REAL)
	call mfree (LPMEM_WXMAX(lpx), TY_REAL)
	call mfree (LPMEM_WXSCALE(lpx), TY_REAL)
	call mfree (LPMEM_WYMIN(lpx), TY_REAL)
	call mfree (LPMEM_WYMAX(lpx), TY_REAL)
	call mfree (LPMEM_WYSCALE(lpx), TY_REAL)
	call mfree (LPMEM_VXMIN(lpx), TY_REAL)
	call mfree (LPMEM_VXMAX(lpx), TY_REAL)
	call mfree (LPMEM_VYMIN(lpx), TY_REAL)
	call mfree (LPMEM_VYMAX(lpx), TY_REAL)
	call mfree (lpx, TY_STRUCT)
end
