include "lpx.h"

# LPL_INIT_LPX -- Initialize the per-curve arrays governing sizes, scales,
# line/marker types etc.

procedure lpl_init_lpx (lpx, ncurves)

pointer	lpx		# per-curve arrays descriptor
int	ncurves		# total curves in run

begin
	call calloc (lpx, LEN_LPX, TY_STRUCT)
	call calloc (LPMEM_LINETYPE(lpx), ncurves, TY_INT)
	call calloc (LPMEM_MAJRX(lpx), ncurves, TY_INT)
	call calloc (LPMEM_MAJRY(lpx), ncurves, TY_INT)
	call calloc (LPMEM_MARKERSIZE(lpx), ncurves, TY_REAL)
	call calloc (LPMEM_MARKERTYPE(lpx), ncurves, TY_INT)
	call calloc (LPMEM_MINRX(lpx), ncurves, TY_INT)
	call calloc (LPMEM_MINRY(lpx), ncurves, TY_INT)
	call calloc (LPMEM_PXMIN(lpx), ncurves, TY_REAL)
	call calloc (LPMEM_PXMAX(lpx), ncurves, TY_REAL)
	call calloc (LPMEM_PXSCALE(lpx), ncurves, TY_REAL)
	call calloc (LPMEM_PYMIN(lpx), ncurves, TY_REAL)
	call calloc (LPMEM_PYMAX(lpx), ncurves, TY_REAL)
	call calloc (LPMEM_PYSCALE(lpx), ncurves, TY_REAL)
	call calloc (LPMEM_WXMIN(lpx), ncurves, TY_REAL)
	call calloc (LPMEM_WXMAX(lpx), ncurves, TY_REAL)
	call calloc (LPMEM_WXSCALE(lpx), ncurves, TY_REAL)
	call calloc (LPMEM_WYMIN(lpx), ncurves, TY_REAL)
	call calloc (LPMEM_WYMAX(lpx), ncurves, TY_REAL)
	call calloc (LPMEM_WYSCALE(lpx), ncurves, TY_REAL)
	call calloc (LPMEM_VXMIN(lpx), ncurves, TY_REAL)
	call calloc (LPMEM_VXMAX(lpx), ncurves, TY_REAL)
	call calloc (LPMEM_VYMIN(lpx), ncurves, TY_REAL)
	call calloc (LPMEM_VYMAX(lpx), ncurves, TY_REAL)
end
