include <ctype.h>
include	"lpl.h"

# LPL_INTYPE -- Determine whether the input specifier is an image section
# or a list.  If the string is STDIN, it is a list; if a subscript is
# present, it is an image; otherwise we must test whether or not it is a
# binary file and make the decision based on that.

int procedure lpl_intype (fname)

char	fname[ARB]
int	first, last, ip
int	access(), strncmp()

begin
	# Strip off any whitespace at the beginning or end of the string.
	for (ip=1;  IS_WHITE(fname[ip]);  ip=ip+1)
	    ;
	first = ip
	for (last=ip;  fname[ip] != EOS;  ip=ip+1)
	    if (!IS_WHITE(fname[ip]))
		last = ip

	if (first == last)
	    return (LIST_INPUT)
	else if (strncmp (fname[first], "STDIN", 5) == 0)
	    return (LIST_INPUT)
	else if (fname[last] == ']')
	    return (IMAGE_INPUT)
	else if (access (fname, 0, TEXT_FILE) == YES)
	    return (LIST_INPUT)
	else
	    return (IMAGE_INPUT)
end
