include <gio.h>

# LPL_LTRANS -- Perform list-input coordinate transformation.

procedure lpl_ltrans (transtr, nelems, value)

char	transtr[ARB]		# (i)   transformation parameter string
int	nelems			# (i)   number of elements in data value array
real	value[ARB]		# (i/o) data value array

int	i

int	strncmp()
real	mkindefr()
extern	mkindefr()
errchk	mkindefr()

begin
	if (strncmp (transtr, "log", 1) == 0)
	    call alogr (value, value, nelems, mkindefr)
	else if (strncmp (transtr, "magnitude", 1) == 0) {
	    call alogr (value, value, nelems, mkindefr)
	    do i = 1, nelems
		if (!IS_INDEFR(value[i]))
		    value[i] = -2.5 * value[i]
	} else if (strncmp (transtr, "inverse", 1) == 0)
	    do i = 1, nelems
		if (value[i] == 0.0)
		    value[i] = INDEFR
		else
		    value[i] = 1.0 / value[i]
	else
	    call eprintf (
		"Warning (LPL_LTRANS): bad list transform reset to `none'\n")
end

# MKINDEFR -- return INDEFR; used as an external reference passed to some
# of the vector op routines for impossible operations.

real procedure mkindefr (r)

real	r

begin
	return (INDEFR)
end
