include <ctotok.h>
include "lpl.h"

define	LEFT		1
define	RIGHT		2

# LPL_PARSE_COORD -- Parse a range specification into its two components.

procedure lpl_parse_coord (instr, minval, maxval)

char	instr[ARB]	# string to be parsed
real	minval		# output minimum value (from left side of separator)
real	maxval		# output maximum value (calculated from right side)

int	state, ip, wip, token
real	bin[2]
char	word[MAXWORDSIZE], op

int	ctor(), ctotok(), strlen()

string	errmsg "LPL_PARSE_COORD: maxwordsize exceeded; coord reset to def.\n"

#debug+
int	debug
common /deb/ debug
#debug-
begin
	# Syntax:  axis = [minval] [SYN_TO maxval]    or
	#	   axis = [minval] [SYN_RANGE range]

	ip = 1
	state = LEFT
	call amovkr (INDEFR, bin, 2)

	repeat {
	    token = ctotok (instr, ip, word, MAXWORDSIZE)
	    if (strlen (word) >= MAXWORDSIZE) {
		call eprintf (errmsg)
		next
	    }

	    switch (token) {
	    case TOK_OPERATOR, TOK_PUNCTUATION:
		state = RIGHT
		op  = word[1]
	    case TOK_NUMBER:
		wip = 1
		if (ctor (word, wip, bin[state]) <= 0)
		    bin[state] = INDEFR
	    }
	} until (token == TOK_EOS)
	
	minval = bin[LEFT]
	if (op == SYN_TO_1 || op == SYN_TO_2)
	    maxval = bin[RIGHT]
	else if (op == SYN_PLUS_1 || op == SYN_PLUS_2)
	    if (!IS_INDEF(minval) && !IS_INDEF(bin[RIGHT]))
		maxval = minval + bin[RIGHT]
	else
	    maxval = INDEFR
end
