include "lpl.h"

# LPL_RDCURVE -- Read a curve into memory.  The input specifier fname may
# either be a list file or image input; lpl_intype determines which, then
# we call the appropriate input routine.

int procedure lpl_rdcurve (lpl, fname, x, y, needtitle, holdtitle, curve)

pointer	lpl		# longplot descriptor (needed for title reference)
char	fname[ARB]	# input specification
pointer	x,y		# now one-d pointers to data arrays
bool	needtitle	# whether to assign title from imheader or inputspec
char	holdtitle[ARB]	# original titlespec from task parameter
int	curve		# curve number

int	lpl_intype(), lpl_rlist2(), lpl_rimage2()
errchk	lpl_intype, lpl_rlist2, lpl_rimage2

begin
	if (lpl_intype (fname) == LIST_INPUT)
	    return (lpl_rlist2 (lpl, fname, x, y, needtitle, curve))
	else
	    return (lpl_rimage2 (lpl, fname, x, y, needtitle, holdtitle, curve))
end
