include "lpx.h"

# LPL_RESET_LPX -- Reset memory for the per-curve arrays governing sizes,
# scales, line/marker types etc.

procedure lpl_reset_lpx (lpx, ncurves)

pointer	lpx		# per-curve arrays descriptor
int	ncurves		# total curves in run

begin
	call realloc (LPMEM_LINETYPE(lpx), ncurves, TY_INT)
	call realloc (LPMEM_MAJRX(lpx), ncurves, TY_INT)
	call realloc (LPMEM_MAJRY(lpx), ncurves, TY_INT)
	call realloc (LPMEM_MARKERSIZE(lpx), ncurves, TY_REAL)
	call realloc (LPMEM_MARKERTYPE(lpx), ncurves, TY_INT)
	call realloc (LPMEM_MINRX(lpx), ncurves, TY_INT)
	call realloc (LPMEM_MINRY(lpx), ncurves, TY_INT)
	call realloc (LPMEM_PXMIN(lpx), ncurves, TY_REAL)
	call realloc (LPMEM_PXMAX(lpx), ncurves, TY_REAL)
	call realloc (LPMEM_PXSCALE(lpx), ncurves, TY_REAL)
	call realloc (LPMEM_PYMIN(lpx), ncurves, TY_REAL)
	call realloc (LPMEM_PYMAX(lpx), ncurves, TY_REAL)
	call realloc (LPMEM_PYSCALE(lpx), ncurves, TY_REAL)
	call realloc (LPMEM_WXMIN(lpx), ncurves, TY_REAL)
	call realloc (LPMEM_WXMAX(lpx), ncurves, TY_REAL)
	call realloc (LPMEM_WXSCALE(lpx), ncurves, TY_REAL)
	call realloc (LPMEM_WYMIN(lpx), ncurves, TY_REAL)
	call realloc (LPMEM_WYMAX(lpx), ncurves, TY_REAL)
	call realloc (LPMEM_WYSCALE(lpx), ncurves, TY_REAL)
	call realloc (LPMEM_VXMIN(lpx), ncurves, TY_REAL)
	call realloc (LPMEM_VXMAX(lpx), ncurves, TY_REAL)
	call realloc (LPMEM_VYMIN(lpx), ncurves, TY_REAL)
	call realloc (LPMEM_VYMAX(lpx), ncurves, TY_REAL)
end
