#{ WAVEPLOT -- Execute task LONGPLOT on wavelength-calibrated images

{
	real	w0, wpc, crpix1, wmax
	int	ndimen, ax_len
	char	w0str, wpcstr
	char	trans_string
	struct	*imfd
	struct	instr
	file	imlist

	# Load images package if necessary.
	if (defpac ("images") == no) {
	    images
	}

	# Set temporary files.
	imlist = mktemp ("tmp$ims")

	# Generate image list.
	files (input, sort-, >imlist)
	imfd = imlist

	print (" ")
	print ("LONGPLOT an image that uses either parameters W0, WPC or FITS parameters")
	print ("CRPIXn, CRDELTn, and CRVALn to transform from pixels to world (data) units")
	print (" ")

	while (fscan (imfd, instr) != EOF) {

#	    hedit (instr, "W0,WPC,i_naxis", ".")
	    imgets (instr, "i_naxis")
	    ndimen = int(imgets.value)
	    imgets (instr, "i_naxis1")
	    ax_len = int(imgets.value)

	    imgets (instr, "W0")
	    w0 = real(imgets.value)
	    w0str = imgets.value
	    imgets (instr, "WPC")
	    wpc = real(imgets.value)
	    wpcstr = imgets.value
#	    imgets (instr, "CRPIX1")
#	    crpix1 = real(imgets.value)

	    wmax = w0 + (ax_len - 1) * wpc

	    print ("number of dimensions = ", ndimen)
	    print ("w0 = ", w0str)
	    print ("wpc = ", wpcstr)
	    print ("wmax = ", wmax)
#	    print ("crpix1 = ", crpix1)

	    trans_string = "p1=" // w0 // " p2=" // wmax
	    print ("trans_string = ", trans_string)
	    longplot (instr, spoolfile=spoolfile, debug=debug,
		xautoexpand=xautoexpand,
	        wx=wx, px=px, xscale=xscale, xround=xround, xt=trans_string, 
		yautoexpand=yautoexpand, wy=wy, py=py, yscale=yscale,
		yround=yround, yt=yt, axis=axis, units=units, xlabel=xlabel,
		ylabel=ylabel, title=title, lbold=lbold, dbold=dbold, 
		floatchar=floatchar, multiple=multiple, plotmode=plotmode,
		mtype=mtype, msize=msize, labelticks=labelticks, 
		majrx=majrx, minrx=minrx, majry=majry, minry=minry, 
		logx=logx, logy=logy, grid=grid, device=device)
	}
	delete (imlist, verify=no)
}

# v = (pix - CRPIXn) * CRDELTn + CRVALn
