procedure mkrunlib (chip)

string	chip				{prompt="Chip name"}

string	master	= "ursa"		{prompt="Master ICE machine"}
string	icepath	= "/iraf/extern/ice"	{prompt="Path to root ICE directory"}
bool	clobber = no			{prompt="Overwrite previous runlib?"}
bool	verbose	= yes			{prompt="Print verbose information?"}

bool	doit	= no	{prompt="Runlib already exists, overwrite?", mode="q"}

begin
	string	runpath	= "ccdacq/lib/runlib"
	string	prefix	= "runlib."

	string	lchip, llchip, runlib, cmd, oldpath, fname[10]
	struct	scmd
	bool	ldoit

	fname[1] = "README"
	fname[2] = "detcap"
	fname[3] = "instrcap"
	fname[4] = "telcap"
	fname[5] = "mkpkg"
	fname[6] = "crxasm.c"
	fname[7] = "macro.ad"
	fname[8] = "macro.bc"
	fname[9] = "token.kp"

	lchip = chip
	print (lchip) | translit ("", "A-Z", "a-z", del-, col-) | scan (llchip)

	fname[10] = llchip // ".*"

	runlib = prefix // lchip

	if (access (runlib)) {
	    if (! clobber) {
		ldoit = doit
	    } else
		ldoit = clobber

	    if (clobber || ldoit) {
		printf ("!rm -rf %s\n", runlib) | cl
	    } else {
		printf ("Runlib is unchanged.\n")
		return
	    }
	}

	# preserve the file dates
	printf ("!rsh %s '(cd %s/%s; tar -cf -\n", master, icepath, runpath) |
	    scan (scmd)
	cmd = scmd			# work around the limited struct length
	cmd = cmd // " " // fname
	cmd = cmd // ")' | tar -xvpf -\n"

	path | scan (oldpath)

	if (verbose)
	    printf ("Making new runlib %s%s.\n", oldpath, runlib)

	mkdir (runlib)
	chdir (runlib)

	if (verbose)
	    print (cmd) | cl
	else
	    print (cmd) | cl >& dev$null

	chdir (oldpath)
end
