# PAIRMASS -- plot the airmass for a given RA & Dec on a given date.

procedure t_pairmass()

pointer	sp, ut, air, buf
double	ra, dec, epoch, ra0, dec0, epoch0
double	longitude, latitude, st, ha, utd, resolution
int	day, month, year, nsteps, i
real	amin, amax

double	clgetd(), ast_mst(), airmass()
bool	clgetb()
int	clgeti()

begin
	ra0 = clgetd ("ra")
	dec0 = clgetd ("dec")
	epoch0 = clgetd ("epoch")

	year = clgeti ("year")
	month = clgeti ("month")
	day = clgeti ("day")

	longitude = clgetd ("longitude")
	latitude = clgetd ("latitude")

	resolution = clgetd ("resolution")
	nsteps = nint (24 * resolution) + 1

	call smark (sp)
	call salloc (ut, nsteps, TY_REAL)
	call salloc (air, nsteps, TY_REAL)
	call salloc (buf, SZ_LINE, TY_CHAR)

	call ast_date_to_epoch (year, month, day, 12.d0, epoch)
	call ast_precess (ra0, dec0, epoch0, ra, dec, epoch)

	do i = 1, nsteps {
	    utd = (i-1) / resolution
	    call ast_date_to_epoch (year, month, day, utd, epoch)
	    st = ast_mst (epoch, longitude)
	    ha = st - ra

	    Memr[ut+i-1] = real (utd)
	    Memr[air+i-1] = real (airmass (ha, dec, latitude))
	}

	if (clgetb ("listout")) {
	    do i = 1, nsteps {
		call printf ("%6.0m\t%8.4f\n")
		    call pargr (Memr[ut+i-1])
		    call pargr (Memr[air+i-1])
	    }
	} else {
	    call sprintf (Memc[buf], SZ_LINE,
		"Airmass vs. UT, %d/%d/%d\nRA=%h, Dec=%h (%g)\nlong=%m, lat=%m")

		call pargi (month)
		call pargi (day)
		call pargi (year)
		call pargd (ra0)
		call pargd (dec0)
		call pargd (epoch0)
		call pargd (longitude)
		call pargd (latitude)

	    call alimr (Memr[air], nsteps, amin, amax)
	    call draw_vector (Memc[buf], Memr[ut], Memr[air],
		nsteps, 0., 24., amin, amax)
	}

	call sfree (sp)
end
