procedure qdisplay (root)

string	root		{prompt="Root image name"}

bool	debias	= yes	{prompt="Perform a rough debiasing?"}
bool	flip	= yes	{prompt="Flip the chips?"}
bool	transpose = yes	{prompt="Transpose chip 2?"}

int	bias1	= 2900	{prompt="Bias offset for chip 1"}
int	bias2	= 2780	{prompt="Bias offset for chip 2"}
int	bias3	= 2290	{prompt="Bias offset for chip 3"}
int	bias4	= 2500	{prompt="Bias offset for chip 4"}
int	window	= 400	{prompt="Pixel window width"}

bool	verbose	= yes	{prompt="Verbose commentary"}
int	frame	= 1	{prompt="Image display frame buffer"}

string	*list

begin
	bool	firsttime = yes

	string	lroot, tmplist, tmpimg, img, sect[4], pos[4], bias[4]
	real	xc, yc, xs, ys, z1, z2
	int	i, c

	lroot = root

	if (verbose)
	    time

	tmplist = mktemp ("tmp")
	tmpimg = mktemp ("tmp")

	sect[1]	= "[*,-*]"
	sect[2]	= "[*,-*]"
	sect[3]	= "[*,-*]"
	sect[4]	= "[-*,*]"

	pos[1]	= "0.25 0.75"
	pos[2]	= "0.25 0.25"
	pos[3]	= "0.75 0.75"
	pos[4]	= "0.75 0.25"

	bias[1]	= bias1
	bias[2]	= bias2
	bias[3]	= bias3
	bias[4]	= bias4

	c = 'a'
	for (i=1; i <= 4; i+=1) {
	    if (transpose && i == 2)
		printf ("%s", tmpimg, >> tmplist)
	    else
		printf ("%s%c", lroot, c, >> tmplist)
		
	    if (flip)
		printf ("%s", sect[i], >> tmplist)

	    printf ("\t%s 0.49 0.49", pos[i], >> tmplist)

	    if (debias)
		printf (" %5d %5d", bias[i], bias[i]+window, >> tmplist)

	    printf ("\n", >> tmplist)

	    c += 1
	}

	if (transpose)
	    if (verbose) {
		printf ("  transposing chip B, `%s'  \n", lroot//"b")
	        $imtranspose (lroot//"b", tmpimg)
	    } else
	        imtranspose (lroot//"b", tmpimg)

	list = tmplist
	for (c='A'; fscan(list,img,xc,yc,xs,ys,z1,z2) != EOF; c+=1) {
	    if (verbose)
		printf ("  displaying chip %c, `%s'\n", c, img)

	    display (img, frame=frame, erase=firsttime, border_erase-, fill+,
		select+, zscale-, zrange-, ztrans="linear", z1=z1, z2=z2,
		xcenter=xc, ycenter=yc, xsize=xs, ysize=ys, >& "dev$null")

	    firsttime = no
	}

	delete (tmplist, ver-, >& "dev$null")

	if (transpose)
	    imdelete (tmpimg, ver-, >& "dev$null")

	if (verbose)
	    time
end
