procedure qdisplay (image)

string	image		{prompt="Image name"}

bool	debias	= yes	{prompt="Perform a rough debiasing?"}
bool	flip	= yes	{prompt="Flip the chips?"}
bool	transpose = yes	{prompt="Transpose chip 2?"}

int	bias1	= 3410	{prompt="Bias offset for chip 1"}
int	bias2	= 5110	{prompt="Bias offset for chip 2"}
int	bias3	= 1550	{prompt="Bias offset for chip 3"}
int	bias4	= 2160	{prompt="Bias offset for chip 4"}
int	window	= 1000	{prompt="Pixel window width"}

bool	verbose	= yes	{prompt="Verbose commentary"}
int	frame	= 1	{prompt="Image display frame buffer"}

string	*list

begin
	bool	firsttime = yes

	string	limage, tmplist, tmpimg, img, sect[4], pos[4], bias[4]
	real	xc, yc, xs, ys, z1, z2
	int	i

	limage = image

	if (verbose)
	    time

	tmplist = mktemp ("tmp")
	tmpimg = mktemp ("tmp")

	if (flip) {
	    sect[1]	= "[1:2080,2049:4096]"
	    sect[2]	= "[2080:1,1:2048]"
	    sect[3]	= "[4160:2081,2049:4096]"
	    sect[4]	= "[2081:4160,1:2048]"
	} else {
	    sect[1]	= "[1:2080,2049:4096]"
	    sect[2]	= "[1:2080,1:2048]"
	    sect[3]	= "[2081:4160,2049:4096]"
	    sect[4]	= "[2081:4160,1:2048]"
	}

	pos[1]	= "0.25 0.75"
	pos[2]	= "0.25 0.25"
	pos[3]	= "0.75 0.75"
	pos[4]	= "0.75 0.25"

	bias[1]	= bias1
	bias[2]	= bias2
	bias[3]	= bias3
	bias[4]	= bias4

	for (i=1; i <= 4; i+=1) {
	    if (transpose && i == 2)
		printf ("%s", tmpimg, >> tmplist)
	    else
		printf ("%s%s", limage, sect[i], >> tmplist)
		
	    printf ("\t%s 0.49 0.49", pos[i], >> tmplist)

	    if (debias)
		printf (" %5d %5d", bias[i], bias[i]+window, >> tmplist)

	    printf ("\n", >> tmplist)
	}

	if (transpose)
	    if (verbose) {
		printf ("  transposing chip 2, `%s'  \n", limage)
	        $imtranspose (limage//sect[2], tmpimg)
	    } else
	        imtranspose (limage//sect[2], tmpimg)

	list = tmplist
	for (i=1; fscan(list,img,xc,yc,xs,ys,z1,z2) != EOF; i+=1) {
	    if (verbose)
		printf ("  displaying chip %d, `%s'\n", i, img)

	    if (debias)
		display (img, frame=frame, erase=firsttime, border_erase-,
		    fill+, select+, zscale-, zrange-, ztrans="linear",
		    z1=z1, z2=z2, xcenter=xc, ycenter=yc, xsize=xs,
		    ysize=ys, >& "dev$null")
	    else
		display (img, frame=frame, erase=firsttime, border_erase-,
		    fill+, select+, xcenter=xc, ycenter=yc, xsize=xs,
		    ysize=ys, >& "dev$null")

	    firsttime = no
	}

	delete (tmplist, ver-, >& "dev$null")

	if (transpose)
	    imdelete (tmpimg, ver-, >& "dev$null")

	if (verbose)
	    time
end
