procedure quad (raw, mosaic)

string	raw		{prompt="Raw multiplexed image"}
string	mosaic		{prompt="Dequaded mosaic"}

int	bias1 = 1500	{prompt="Rough bias offset for chip 1"}
int	bias2 =  880	{prompt="Rough bias offset for chip 2"}
int	bias3 =  430	{prompt="Rough bias offset for chip 3"}
int	bias4 =  660	{prompt="Rough bias offset for chip 4"}

int	xgap = 32	{prompt="X pixel gap", min=0}
int	ygap = 32	{prompt="Y pixel gap", min=0}

int	blank = 0	{prompt="Pixel value for gaps"}

bool	verbose = yes	{prompt="Verbose commentary"}

begin
	int	os=32
	int	hs=16
	int	ds=64
	int	qs=128

	string	lraw, lmos, rs[8], tmpimg, tmpraw, tmpoff, tmpzero
	int	quad, nx, ny, nx1, ny1, xo[8], yo[8], bias[8]

	lraw = raw
	lmos = mosaic

	tmpimg = mktemp ("tmpmos")
	tmpraw = mktemp ("tmpmos")
	tmpoff = mktemp ("tmpmos")
	tmpzero = mktemp ("tmpmos")

	hselect (lraw, "naxis1,naxis2", "yes") | scan (nx, ny)
	if (mod(nx,4) != 0 || mod(ny,4) != 0)
	    print ("WARNING: input image axes aren't divisible by 4!")

	nx1 = nx/2 - 32
	ny1 = ny/2

	rs[1] = lraw // "["//ds+1//":"//nx//":4,"//ny-1//":1:2]"
	rs[2] = lraw // "[1:"//nx-ds-3//":4,"//ny//":2:2]"
	rs[3] = lraw // "["//nx-2//":2:4,1:"//ny-1//":2]"
	rs[4] = lraw // "["//nx-qs-2//":2:4,2:"//ny//":2]"
	rs[5] = lraw // "[3:"//nx-1//":4,"//ny-1//":1:2]"
	rs[6] = lraw // "[3:"//nx-qs-1//":4,"//ny//":2:2]"
	rs[7] = lraw // "["//nx//":"//ds+4//":4,1:"//ny-1//":2]"
	rs[8] = lraw // "["//nx-ds//":4:4,2:"//ny//":2]"

	print (rs, >> tmpraw)

	xo[1] = 0;			yo[1] = ny1 + ygap
	xo[2] = nx1/2;			yo[2] = ny1 + ygap
	xo[4] = 0;			yo[4] = 0
	xo[3] = (nx1-os)/2;		yo[3] = 0
	xo[5] = nx1 + xgap;		yo[5] = ny1 + ygap
	xo[6] = nx1 + xgap + (nx1-os)/2;yo[6] = ny1 + ygap
	xo[8] = nx1 + xgap;		yo[8] = 0
	xo[7] = nx1 + xgap + nx1/2;	yo[7] = 0

	print (xo, "\t", yo, >> tmpoff)

	bias[1] = bias1; bias[2] = bias1
	bias[3] = bias2; bias[4] = bias2
	bias[5] = bias3; bias[6] = bias3
	bias[7] = bias4; bias[8] = bias4

	print (bias, >> tmpzero)

	if (verbose) {
	    printf ("\n  Dequading %s:\n", lraw)
	    time; printf ("  ")
	    $imcombine ("@"//tmpraw, lmos, outtype="short",
		blank=blank, offsets=tmpoff, zero="@"//tmpzero)
	} else {
	    imcombine ("@"//tmpraw, lmos, outtype="short",
		blank=blank, offsets=tmpoff, zero="@"//tmpzero)
	}

	delete (tmpraw, ver-, >& "dev$null")
	delete (tmpoff, ver-, >& "dev$null")
	delete (tmpzero, ver-, >& "dev$null")

	if (verbose) {
	    printf ("\n  Transposing quadrant 2:\n")
	    $imtranspose (lmos//"[1:"//nx1//",1:"//ny1//"]", tmpimg)
	    $imcopy (tmpimg, lmos//"[1:"//nx1//",1:"//ny1//"]", verb-)
	    time; printf ("\n")
	} else {
	    imtranspose (lmos//"[1:"//nx1//",1:"//ny1//"]", tmpimg)
	    imcopy (tmpimg, lmos//"[1:"//nx1//",1:"//ny1//"]", verb-)
	}

	imdelete (tmpimg, ver-, >& "dev$null")
end
