include <error.h>
include <imhdr.h>
include <imset.h>
include "rccd.h"

int procedure rcd_read_ccd (ccdfile, iraffile)

char	ccdfile[ARB]		# CCD file name
char	iraffile[ARB]		# IRAF file name

int 	ccd_fd, stat
int	mtopen(), immap(), rcd_read_header()
pointer im, sp 

errchk  smark, sfree, mtopen, immap, rcd_read_header, rcd_read_image
errchk  imdelete, close, imunmap

include "rccd.com"

begin
	#Open input CCD data
	ccd_fd = mtopen (ccdfile, READ_ONLY, 0)

	# Allocate memory for program data structure
	call smark (sp)

	# Create IRAF image header.  If only aheader listing is desired 
	# then map the scratch image onto DEV$NULL (faster than a real file).

	if (make_image == NO)
	    call strcpy("dev$null", iraffile, SZ_FNAME)
	im = immap (iraffile, NEW_IMAGE, LEN_USER_AREA)

	# Read header.  EOT is signalled by an EOF status from fits_read_header.
	# Create an IRAF image if desired.

	iferr {
		stat = rcd_read_header(ccd_fd,im)
		if (stat == EOF)
		    call printf ("End of data\n")
		else {
			if (make_image == YES)
			    call rcd_read_image (ccd_fd, im)
		}
	} then
		call erract (EA_WARN)

	# Close files and clean up.
	call imunmap (im)

	if (stat == EOF || make_image == NO) {
	    call imdelete (iraffile)
	} 

	call close (ccd_fd)
	call sfree (sp)

	return (stat)

end
