include <imhdr.h>
include <imio.h>
include <mach.h>
include	"rccd.h"

define	NEPSILON 10.0d0

# RCD_READ_HEADER -- Read a CCD header.
# EOT is detecxted by an EOF on the first read and EOF is returned to the
# calling routine.  Any error is passed to the calling routine.


int procedure rcd_read_header (ccd_fd, im)

int	ccd_fd			# CCD file descriptor
pointer	im			# IRAF image descriptor

int     len,i, k, idx, hv, xframe, frmno, done
real    ts, time
short   hrec[HSIZE], tout, tint, lmask, hmask
char	t1[3], t2[3],t3[3], ctemp[80], ttemp[80]
int	rcd_init_read_pixels(), strlen(), 
	rcd_read_pixels() 

errchk	rcd_init_read_pixels, rcd_read_pixels

include "rccd.com"

begin

	lmask = 127
	hmask = 32512

# RCD_READ_HEADER -- Read a CCD header.
# EOT is detecxted by an EOF on the first read and EOF is returned to the
# calling routine.  Any error is passed to the calling routine.

	# Object name not present in ccd tape
	call strcpy ("Unknown", OBJECT(im), SZ_OBJECT)

	# Read in header 

	i = rcd_init_read_pixels (HSIZE, CCD_SHORT, LSBF, TY_USHORT)

	i = rcd_read_pixels (ccd_fd, hrec, HSIZE)

	if (i != HSIZE)
	    call error (2, "READ_HEADER: Error reading CCD header")

	# Process  header information 
	hv = hrec[8]

	# Institute of Origin

	# Calculate dimension and offset for the image and bias area 
	switch (hv) {
		case 0, 1, 2, 3:
			if (hv < 2) {
			    dim1 = 512
			    dim2 = 501
			    NAXISN (im, 2) = 500 
			}
			else {
				dim1 = hrec[10] 
				dim2 = hrec[11] 
				NAXISN (im, 2) = dim2 - 1
			}
			
		 	lpr = 1
		 	flip = 1
			yoff = 1
			xoff = 8 
			if (nostrip == 1)
			    NAXISN (im, 1) = dim1
			else NAXISN (im, 1) = 500
		case 4, 5, 6, 999:
			 if (hv == 999) {
			      xoff = 8 
			      yoff = 1
			  }
			 else {
				 xoff = hrec[13] 
				 yoff = hrec[14] 
				 if (hv == 4 || hv == 5) {
				     xoff = xoff * -1 
				     yoff = yoff * -1     
				 } 
			  }
				   	
		 	  lpr = hrec[12] 
			  dim1 = hrec[10]
			  dim2 = hrec[11] 
			  flip = hrec[7] 
		 	  if (hv == 999 && flip < 0)
		     	      flip = 1

			  # determine iysize
			  switch (dim2) {
					case 501:
						   NAXISN(im, 2) = 500
					case 132:
						   NAXISN(im, 2) = 125
					case 208,408,508,584,808:
						   NAXISN(im, 2) = dim2 - 8
					case 256:
					   	   NAXISN(im, 2) = 250
			}

			# determine ixsize, i.e. NAXISN(im, 1) 
			if (nostrip == 1)
			    NAXISN(im, 1) = dim1
			else switch (dim1) { 
					case 288:
						   NAXISN(im, 1) = 250
					case 412:
						   NAXISN(im, 1) = 400 
					case 416:
						   NAXISN(im, 1) = 385
					case 512:
						   NAXISN(im, 1) = 500
				        case 812, 832:
						   NAXISN(im, 1) = 800
			}
		default:
			 call error (1, "bad header version")
	}

	# Determine origin and sensor 
	xframe = hrec[17]
	if (xframe == 3)
	    call strcpy ("UKIRT-MKA                          / institution of origin\n", 
		     HISTORY(im), SZ_HISTORY)
	else call strcpy ("UHIFA-MKA88                       / institution of origin\n", 
		     HISTORY(im), SZ_HISTORY)
	switch(xframe) {
		case 1, 4, 5, 6:
			call sprintf(ctemp, 17, "Three Phase CCD")
		case 2:
			call sprintf(ctemp, 18, "Virtual Phase CCD")
		case 3:
			call sprintf(ctemp, 4, "GEC")
		default:
			call sprintf(ctemp, 7, "Unknown")
	}

	call printf("Sensor = %s %d x %d pixels (incl. engineering data)\n")
		call pargstr(ctemp)
		     call pargi(dim1)
			  call pargi(dim2)
	len = strlen(ctemp) + 13
	call sprintf(ttemp, len, "SENSOR  = '%s'\n")
		     call pargstr(ctemp)
	call strcat (ttemp, UNKNOWN(im), (LEN_USER_AREA -1) * SZ_STRUCT)
	
	# Determine exposure time
	if (hrec[5] == 1)
	    ts = 0.1
	else ts = 0.01
	time = hrec[4] * ts
	call printf("Exposure was %.2f seconds\n")
		call pargr(time)

	call sprintf(ctemp, 8, "%.2f")
			call pargr(time)
	len = strlen(ctemp) + 56 
	call sprintf(ttemp, len, 
             "EXPOSURE= '%s'                  / exposure time in seconds\n")
	     	call pargstr(ctemp)
	call strcat (ttemp, UNKNOWN(im), (LEN_USER_AREA - 1) * SZ_STRUCT)

	# Frame Number
	frmno = hrec[1]
	call printf("Frame # = %d  Header Version = %d\n")
	     call pargi(frmno)
	     call pargi(hv)
	call sprintf(ctemp, 27, "FRAME   = '%d'\n")
		call pargi(frmno)
	call strcat (ctemp, UNKNOWN(im), (LEN_USER_AREA - 1) * SZ_STRUCT)

	# Header Version
	call sprintf(ctemp, 32, "VERSION = '%d'\n")
		call pargi(hv)
	call strcat (ctemp, UNKNOWN(im), (LEN_USER_AREA - 1) * SZ_STRUCT)

	if ( xframe != 3 && ( hv == 6 || hv == 999 ) ) {

	     # Observation Date
    	     # Day
	     tint = hrec[35]
	     tout = and(tint,lmask)
	     t1[1] = tout
	     tint = hrec[35]
	     tout = and(tint,hmask) / 16 / 16
	     t1[2] = tout
	     t1[3] = EOS
             # Month
	     tint = hrec[34]
	     tout = and(tint,lmask)
	     t2[1] = tout
	     tint = hrec[34]
	     tout = and(tint,hmask) / 16 / 16
	     t2[2] = tout
	     t2[3] = EOS
             # Year
	     tint = hrec[33]
	     tout = and(tint,lmask)
	     t3[1] = tout
	     tint = hrec[33]
	     tout = and(tint,hmask) / 16 / 16
	     t3[2] = tout
	     t3[3] = EOS
	     call sprintf(ctemp, 20, "%s/%s/%s") 
	    	     call pargstr(t1)
		    	  call pargstr(t2)
			       call pargstr(t3)
	     call sprintf(ttemp, 80, 
			"DATE-OBS= '%s'              / dd/mm/yy observation\n")
	    	     call pargstr(ctemp)
	     call strcat (ttemp, UNKNOWN(im), (LEN_USER_AREA - 1) * SZ_STRUCT)
	     call printf("Data Recorded on %s  ")
		  call pargstr(ctemp)

	     # Universal Time
	     # Hour	
	     tint = hrec[36]
	     tout = and(tint,lmask)
	     t1[1] = tout
	     tint = hrec[36]
	     tout = and(tint,hmask) / 16 / 16
	     t1[2] = tout
	     t1[3] = EOS
             # Minute
	     tint = hrec[37]
	     tout = and(tint,lmask)
	     t2[1] = tout
	     tint = hrec[37]
	     tout = and(tint,hmask) / 16 / 16
	     t2[2] = tout
	     t2[3] = EOS
             # Second
	     tint = hrec[38]
	     tout = and(tint,lmask)
	     t3[1] = tout
	     tint = hrec[38]
	     tout = and(tint,hmask) / 16 / 16
	     t3[2] = tout
	     t3[3] = EOS
	     call sprintf(ctemp, 20, "%s:%s:%s")
		     call pargstr(t1)
			  call pargstr(t2)
			       call pargstr(t3)
	     call sprintf(ttemp, 80,
		"UT      = '%s'              / universal time\n")
		     call pargstr(ctemp)
	     call strcat (ttemp, UNKNOWN(im), (LEN_USER_AREA - 1) * SZ_STRUCT)
	     call printf("at %s universal time\n")
		    call pargstr(ctemp)
	}

	# Comments String
	if (hv == 6 && xframe != 3) {
		idx = 47
		k = 0
		done = NO
		repeat {
		 idx = idx + 1
		 k = k + 1
		 tint = hrec[idx]
		 tout = and(tint,lmask)
		 if (tint == -1)
			done = YES
	         else {
			ctemp[k] = tout
		 	k = k + 1
			tint = hrec[idx]
			tout = and(tint,hmask) / 16 / 16
			if (tout == 255)
				done = YES
			else ctemp[k] = tout
		 }
		} until (done == YES || idx == 82)
		ctemp[k] = EOS
		if (strlen(ctemp) != 0) {
			call sprintf(ttemp, 80, "COMMENT = %s\n")
			 call pargstr(ctemp)
	            call strcat (ttemp, UNKNOWN(im), 
			(LEN_USER_AREA - 1) * SZ_STRUCT)
	        }
	}

	# Get bias dimension and offset 
	if (hv < 6) { # Hard wired before header version 6 
	    switch (dim1) {
		case 512:
			switch (dim2) {
				case 132:
					byo = 16
					bysize = 96
				case 256:
					byo = 64
					bysize = 128
				default:
			    		byo = 124
			    		bysize = 256
			}
			bxo = 0
			bxsize = 8
		case 832:
			switch (dim2) {
				case 208:
					byo = 5
					bysize = 192
				case 408:
					byo = 9
					bysize = 384
				default:
			    		byo = 17
			    		bysize = 768
			}
			bxo = 5
			bxsize = 16
		case 288:
			    byo = 17
			    bysize = 218
			    bxo = 8
			    bxsize = 8
	     }
	}
	else {
		byo = hrec[22] 
		bxo = hrec[21] 
		bxsize = hrec[23] 
		bysize = hrec[24] 
	}
	NAXIS(im) = 2
	PIXTYPE(im) = TY_SHORT
	return(NO)
end
