# CCD Definitions

# The CCD standard readable by the CCD reader using these definitions:
# 
# 1.  8 bits / byte
# 2.  ASCII character code
# 3.  MII data format (i.e. 8 bit unsigned integers and 16 and 32 bit signed
#     twos complement integers with most significant bytes first.)
#     See mii.h.
#
# The number of CCD bytes in the header is normally 1024but may be specified
# by the user.

# Define the bits per pixel and precision of the 3 basic CCD types

define	CCD_BYTE	8	# Bits in a CCD byte
define	CCD_SHORT	16	# Bits in a CCD short
define	CCD_LONG	32	# Bits in a CCD long

define	CCDB_PREC	3	# Decimal digits of precision in a CCD byte
define	CCDS_PREC	5	# Decimal digits of precision in a CCD short
define	CCDL_PREC	10	# Decimal digits of precision in a CCD long

define	LSBF		YES	# Whether byte swap is necessary 
define  HSIZE		512	# CCD header size
define  PPLMAX		832	# Maximum pixels per row 

# Additional IRAF header parameters

define	PIXTYPE		IM_PIXTYPE($1)
define	NBPIX		IM_NBPIX($1)
define	IRAFMAX		IM_MAX($1)
define	IRAFMIN		IM_MIN($1)
define	LIMTIME		IM_LIMTIME($1)

# Addition CCD header parameters

# Mapping of CCD Keywords to IRAF image header

define	NAXIS	 IM_NDIM($1)
define	NAXISN	 IM_LEN($1,$2)
define	OBJECT	 IM_TITLE($1)
define	HISTORY	 IM_HISTORY($1)
define	UNKNOWN	 Memc[($1+IMU-1)*SZ_STRUCT+1]	# All unrecognized keywords
						# are stored here

define	SZ_OBJECT	SZ_IMTITLE
define	SZ_HISTORY	SZ_IMHIST
define	SZ_FCTYPE	SZ_CTYPE

define	LEN_USER_AREA	1024		# additional image header
