# Added xframe 6, Jan 9, 1989.

include <error.h>
include <fset.h>

define	MAX_RANGES	100
define	NTYPES	7


# RCCD -- Read CCD format data.  Further documentation given in rccd.hlp

procedure t_rccd()

char	infile[SZ_FNAME]		# fits file
char	outfile[SZ_FNAME]		# IRAF file
char	in_fname[SZ_FNAME]		# input file name
char	out_fname[SZ_FNAME]		# output file name
char	file_list[SZ_LINE]		# list of tape files

pointer list
int     lenlist, junk 
int	range[MAX_RANGES*2+1], nfiles, file_number, offset, stat 

bool	clgetb()
char	clgetc()
int	rcd_get_image_type()
int	clgeti(), mtfile(), strlen(), btoi()
int	rcd_read_ccd(), decode_ranges(), get_next_number()
int	fntgfnb()
int     fntlenb()
int     fntopnb()
include	"rccd.com"

begin
	call fseti (STDOUT, F_FLUSHNL, YES)

	# Get parameters.
	call clgstr ("ccd_file", infile, SZ_FNAME)

	# Set options
	make_image = btoi (clgetb ("make_image"))

	if (make_image == YES) {
	    data_type = rcd_get_image_type (clgetc ("datatype"))
	    call clgstr ("iraf_file", outfile, SZ_FNAME)
	    offset = clgeti ("offset")
	    nostrip = btoi (clgetb ("nostrip"))
	} else
	    outfile[1] = EOS

	# Request the input files to be converted if the input file is a
	# tape device.  Otherwise, convert only the first file.
	if (mtfile (infile) == YES) {
	    list = NULL
	    if (infile[strlen(infile)] != ']') 
	        call clgstr ("file_list", file_list, SZ_LINE)
	    else 
	        call strcpy ("1", file_list, SZ_LINE)
	} else {
		list = fntopnb (infile,YES)
		lenlist = fntlenb (list)
		if (lenlist > 0) {
		    call sprintf (file_list,SZ_LINE, "1-%d")
			call pargi (lenlist)
		} else
		    call sprintf (file_list, SZ_LINE, "0")
	}
	if (decode_ranges (file_list, range, MAX_RANGES, nfiles) == ERR)
	    call error (1, "T_RCCD: Illegal file number list")

	# Read successive CCD files, convert and write into a numbered
	# succession of output IRAF files.
	file_number = 0
	while (get_next_number (range, file_number) != EOF) {

	    # Get input file name
	    if (list != NULL)
		junk = fntgfnb (list, in_fname, SZ_FNAME)
	    else {
	    	   # Get names of input and output files.
	    	   call strcpy (infile, in_fname, SZ_FNAME)
		   if (infile[strlen(infile)] != ']') {
			call sprintf (in_fname[strlen(in_fname)+1],SZ_FNAME,
				"[%d]")
			call pargi (file_number)
		    }
	    }
	    # Get out file name
	    call strcpy (outfile, out_fname, SZ_FNAME)
		
	    if (nfiles > 1) {
		call sprintf (out_fname[strlen(out_fname)+1], SZ_FNAME, "%03d")
		    call pargi (file_number + offset)
	    }

	    # Convert CCD file to the output IRAF file.
	    # If EOT is reached then exit.
	    # If an error is detected then print a warning and continue with
	    # the next file.

	    iferr (stat = rcd_read_ccd (in_fname, out_fname))
		call erract (EA_FATAL)
	    if (stat == EOF)
		return
	}
end


# RCD_GET_IMAGE_TYPE -- Convert a character to and IRAF image type.

int procedure rcd_get_image_type (c)

char	c
int	type_codes[NTYPES], i
int	stridx()
string	types "usilrdx"			# supported image data types
data	type_codes /TY_USHORT, TY_SHORT, TY_INT, TY_LONG, TY_REAL,
		    TY_DOUBLE, TY_COMPLEX/
begin
	i = stridx (c, types)
	if (i == 0) 
	    return (ERR)
	else 
	    return (type_codes[stridx(c,types)])
end
