# SHIFTLIST -- make a list of X and Y shifts relative to a reference
# image by pointing at a common source on the image display.

procedure shiftlist (reference, images, shifts)

string	reference		{prompt="Reference image"}
string	images			{prompt="List of images"}
string	shifts			{prompt="Output shift list"}

int	frame	= 1		{prompt="Frame for displaying images"}
imcur	*cursor	= ""		{prompt="Image cursor"}
bool	verbose	= yes		{prompt="Print info on the STDOUT, too?"}

string	*list

begin
	string	code = "q"
	string	l_refer, l_images, l_shifts, img, imgfile
	real	x, y, xref, yref, xshift, yshift
	int	junk, n

	l_refer = reference
	l_images = images
	l_shifts = shifts

	if (access(shifts))
	    error (1, "Shift file already exists!")

	if (verbose) {
	    print ("\nThe task displays the reference and each image in turn.")
	    print ("Center the same source in each image using the flashing")
	    print ("`target' cursor.  Press the  <spacebar>  to record each")
	    print ("position and to move on to the next image, or press `q'")
	    print ("to exit the program.   Zooming each image is permitted.\n")

	    print ("Displaying the reference, ", l_refer, ":")
	    display (l_refer, frame)
	    print ("Center the reference object, press <spacebar>:")
	} else
	    display (l_refer, frame, >& "dev$null")

	if (fscan(cursor,xref,yref,junk,code) < 4 || code=="q" || code=="Q")
	    return

	imgfile = mktemp ("tmp$junk")
	sections (l_images, option="fullname", > imgfile)

	list = imgfile
	while (fscan (list, img) != EOF) {
	    if (verbose) {
		print ("\nDisplaying ", img, ":")
		display (img, frame)
		print ("Center the object, press <spacebar>:")
	    } else
		display (img, frame, >& "dev$null")

	    if (fscan(cursor,x,y,junk,code) < 4 || code=="q" || code=="Q") {
		list = ""; delete (imgfile, ver-, >& "dev$null")
		return
	    }

	    xshift = xref - x
	    yshift = yref - y

	    print (xshift, " ", yshift, >> l_shifts)
	    if (verbose)
		print ("Xshift = ", xshift, ", Yshift = ", yshift)
	}

	list = ""; delete (imgfile, ver-, >& "dev$null")
end
