c SPLIST -- list a 1D IRAF file to a textfile 
c  first line is the image name and title

c various versions of 1987: Pat Seitzer

	program splist

	parameter (nmax=4096)
	character*80 image, errmsg, ofile, title
	integer axlen(7)
	dimension data(nmax)

	call clargc(1, image, ier)
	if (ier.ne.0) then
		write (6,10)
10		format(1x,' image : '$)
		read (5,15) image
15		format(a)
	endif

	call clargc(2, ofile, ier)
	if (ier.ne.0) then
		write (6,20)
20		format(1x,' output file : '$)
		read (5,15) ofile
	endif

	call imopen (image, 1, im, ier)
	if (ier.ne.0) goto 900
	call imgsiz (im, axlen, naxis, dtype, ier)
	nx = axlen(1)
	if (nx.gt.nmax) then
		write (6,25) nx, nmax
25		format (/1x,' image length greater than ',i6,' pixels')
		stop
	endif
	if (naxis.gt.1) then
		write (6,30) 
30		format (/1x,' not a one dimensional image!')
		stop
	endif

	call imgkwc (im, 'title', title, ier)
	if (ier.ne.0) goto 900

c if the data is wavelength calibrated, get the scale
	call imgkwr (im, 'CRVAL1', w0, ier)
	if (ier.eq.0) then
		call imgkwr (im, 'CDELT1', wpc, ier)
		if (ier.ne.0) goto 900
	else
		w0 = 1.
		wpc = 1.
	endif

	call imgl1r (im, data, ier)
	if (ier.ne.0) goto 900

	open (unit=21, file=ofile, status='new', err=950)

	write (21, 35) image, title
35	format (1x,'# ',a20,a40)

c wavelength will be output in Angstroms (hence the fudge if in meters)
c  if CRVAL1 exists; else by pixel #
	do 50 i = 1, nx
		wave = w0 + float(i-1)*wpc
		if (w0.lt.1.e-5) wave=wave*1.e10
		write (21, 40) wave, data(i)
40		format(1x,f12.4,2x,e12.6)
50	continue
	close(21)
	stop

900	call imemsg (ier, errmsg)
	write (6,905) errmsg
905	format(/1x,' Error : ',a80)
	stop

950	write (6,955) ofile
955	format (/1x,' Error in opening file : ',a30)
	stop

	end	
