define	MAX_RANGES	100
define	SZ_CMD		10

# Task to drive tftp transfer of PDS data.  A command file is written
# from which tftp reads.  The output format is specified by the "format"
# argument, but it must agree with the format set by the user at the PDS.
# If there is a discrepancy, tftp reports the error and continues processing.

procedure t_getpds

pointer	sp, cmd, host, fmt, flist, osc, oname, cfile
int	vms, files[3, MAX_RANGES], fd, nfiles, this_file, status
string	vmscmd  "@"
string  unixcmd "csh "

bool	streq()
int	open(), decode_ranges(), get_next_number(), oscmd()

begin
	call smark (sp)
	call salloc (cmd,   SZ_LINE, TY_CHAR)
	call salloc (host,  SZ_FNAME, TY_CHAR)
	call salloc (fmt,   SZ_FNAME, TY_CHAR)
	call salloc (flist, SZ_FNAME, TY_CHAR)
	call salloc (osc,   SZ_CMD,   TY_CHAR)
	call salloc (oname, SZ_FNAME, TY_CHAR)
	call salloc (cfile, SZ_FNAME, TY_CHAR)

	# Open temporary file of tftp commands

	call mktemp ("cfile", Memc[cfile], SZ_FNAME)
	call strcat (".com", Memc[cfile], SZ_FNAME)
	fd = open (Memc[cfile], NEW_FILE, TEXT_FILE)

	# Figure out what OS command to output
	call zghost (Memc[host], SZ_FNAME)
	call strupk (Memc[host], Memc[host], SZ_FNAME)
	if (streq (Memc[host], "draco") || streq (Memc[host], "vela")) {
	    vms = YES
	    call strcpy (vmscmd, Memc[osc], SZ_CMD)
	} else {
	    vms = NO
	    call strcpy (unixcmd, Memc[osc], SZ_CMD)
	}

	# Get cl parameters
	call clgstr ("file_list", Memc[flist], SZ_FNAME)
	if (decode_ranges (Memc[flist], files, MAX_RANGES, nfiles) == ERR)
	    call error (1, "Error specifying file_list")

	call clgstr ("format",  Memc[fmt],  SZ_FNAME)
	call clgstr ("outname", Memc[oname], SZ_FNAME)

	if (vms == YES)
	    call putline (fd, "$ tftp\n")
	else
	    call putline (fd, "tftp <<END_CMDS\n")

	call putline (fd, "verbose\n")
	call putline (fd, "connect fornax\n")
	call putline (fd, "mode binary\n")

	while (get_next_number (files, this_file) != EOF) {
	    call sprintf (Memc[cmd], SZ_LINE, "get %s_%d %s%03d\n")
		call pargstr (Memc[fmt])
		call pargi   (this_file)
		call pargstr (Memc[oname])
		call pargi   (this_file)

	    call putline (fd, Memc[cmd])
	}

	call putline (fd, "quit\n")
	if (vms == YES)
	    call putline (fd, "$ exit\n")
	else
	    call putline (fd, "END_CMDS\n")

	call sprintf (Memc[cmd], SZ_LINE, "%s%s")
	    call pargstr (Memc[osc])
	    call pargstr (Memc[cfile])

	call close (fd)

	status = oscmd (Memc[cmd], "", "", "")

	call delete (Memc[cfile])
	call sfree (sp)
end
