# Copyright(c) 1986 Association of Universities for Research in Astronomy Inc.

include	<imhdr.h>

task	listvalue = t_listvalue

# LISTVALUES -- List the coordinates of all pixels with the specified value.
# Each pixel is printed on a separate line, preceded by its coordinates.
# The images or image sections may be of any dimension, but the pixels are
# interpreted as integers.

procedure t_listvalue()

bool	verbose
int	i, j, npix, ndim, value
long	v[IM_MAXDIM], last_v[IM_MAXDIM]
pointer	im, line, imlist, image, sp

bool	clgetb()
int	clgeti(), imgnli(), imtgetim()
pointer	imtopenp(), immap()

begin
	call smark (sp)
	call salloc (image, SZ_FNAME, TY_CHAR)

	imlist = imtopenp ("images")
	verbose = clgetb ("verbose")
	value = clgeti ("value")

	while (imtgetim (imlist, Memc[image], SZ_FNAME) != EOF) {

	    # Print banner string.
	    if (verbose) {
		call printf ("\n#Image: %s\n\n")
		    call pargstr (Memc[image])
	    }

	    # Open the input image.
	    im = immap (Memc[image], READ_ONLY, 0)
	    call amovkl (long (1), v, IM_MAXDIM)
	    call amovl (v, last_v, IM_MAXDIM)
	    npix = IM_LEN(im,1)
	    ndim = IM_NDIM(im)

	    while (imgnli (im, line, v) != EOF) {
		do i = 1, npix
		    if (Memi[line+i-1] == value) {
			call printf ("%3d")		    # X
			    call pargi (i)

			do j = 2, ndim {		    # Y, Z, etc.
			    call printf (" %3d")
				call pargl (last_v[j])
			}

			call printf ("\n")
		    }

		call amovl (v, last_v, IM_MAXDIM)
	    }

	    call imunmap (im)
	}

	call imtclose (imlist)
	call sfree (sp)
end
