# LUTREPLACE -- replace short pixel values from an eight bit lookup table

include <imhdr.h>

procedure t_lutreplace ()

pointer	image, lookup, im, buf1, buf2, lut, sp
int	fd, npix, nlines, linenum
short	index, value

pointer	immap(), imgl2s(), impl2s()
int	open(), fscan(), nscan()

begin
	call smark (sp)
	call salloc (image, SZ_FNAME, TY_CHAR)
	call salloc (lookup, SZ_FNAME, TY_CHAR)
	call salloc (lut, 256, TY_SHORT)

	call clgstr ("image", Memc[image], SZ_FNAME)
	call clgstr ("lookup", Memc[lookup], SZ_FNAME)

	im = immap (Memc[image], READ_WRITE, 0)
	fd = open (Memc[lookup], READ_ONLY, TEXT_FILE)

	do index = 0, 255
	    Mems[lut+index] = 0

	while (fscan (fd) != EOF) {
	    call gargs (index)
	    call gargs (value)
	    if (nscan() != 2)
		next
	    if (index < 0 || index > 255)
		next
	    if (value < 0 || value > 255)
		next
	    Mems[lut+index] = value
	}

	npix = IM_LEN(im,1)
	nlines = IM_LEN(im,2)

	do linenum = 1, nlines {
	    buf1 = imgl2s (im, linenum)
	    buf2 = impl2s (im, linenum)

	    call aluts (Mems[buf1], Mems[buf2], npix, Mems[lut])
	}

	call close (fd)
	call imunmap (im)

	call sfree (sp)
end
