include	<mach.h>

define MAX_RANGES	100

# SZ_FORMAT1 should be the number of digits in MAX_NDIGITS itself, plus one.
define MAX_NDIGITS	99
define SZ_FORMAT1	3

procedure t_ranges ()

char	prepend[SZ_LINE]
char	ranges[SZ_LINE]
char	append[SZ_LINE]
char	format1[SZ_FORMAT1]
char	format2[SZ_LINE]
int	recs[3, MAX_RANGES], nrecs, trecs
int	num, n1, n2, ndigits, junk
int	floor, ceiling, mini, maxi, total_min, total_max
bool	check, exclude, decreasing

int	decode_ranges(), get_next_number(), get_previous_number()
int	clgeti(), itoc()
bool	clgetb(), streq()

begin
	call clgstr ("ranges", ranges, SZ_LINE)

	if (streq (ranges, "INDEF")) {
	    call clputi ("minimum", INDEFI)
	    call clputi ("maximum", INDEFI)
	    call clputi ("number", 0)
	    call clputi ("total", 0)
	    return
	}

	if (decode_ranges (ranges, recs, MAX_RANGES, trecs) == ERR)
	    call error (0, "Bad range specification")

	floor = clgeti ("floor")

	if (IS_INDEFI (floor))
	    floor = 1
	else
	    floor = min (max (floor, 1), MAX_INT - 1)

	ceiling = clgeti ("ceiling")

	if (IS_INDEFI (ceiling))
	    ceiling = MAX_INT - 1
	else
	    ceiling = min (max (ceiling, 1), MAX_INT - 1)

	if (floor > ceiling)
	    call error (0, "Floor is greater than ceiling")

	total_min = 0
	total_max = MAX_INT
	if (  get_next_number   (recs, total_min) == EOF ||
	    get_previous_number (recs, total_max) == EOF)
		call error (0, "No values in range")

	mini = floor - 1
	maxi = ceiling + 1
	if (  get_next_number   (recs, mini) == EOF ||
	    get_previous_number (recs, maxi) == EOF || mini > maxi) {

	    call clputi ("minimum", floor)
	    call clputi ("maximum", ceiling)
	    call clputi ("total", 0)
	    call clputi ("number", 0)
	    return
	}

	call clputi ("minimum", mini)
	call clputi ("maximum", maxi)
	call clputi ("total", trecs)

	if (clgetb ("quiet")) {
	    call clputi ("number", INDEFI)
	    return
	}

	call clgstr ("prepend", prepend, SZ_LINE)
	call clgstr ("append", append, SZ_LINE)

	ndigits = clgeti ("ndigits")

	if (IS_INDEFI (ndigits))
	    ndigits = 0
	else
	    ndigits = min (max (ndigits, 0), MAX_NDIGITS)

	junk = itoc (ndigits, format1, SZ_FORMAT1)

	call strcpy ("%s%", format2, SZ_LINE)
	if (clgetb ("zerofill")) call strcat ("0", format2, SZ_LINE)
	call strcat (format1, format2, SZ_LINE)
	call strcat ("u%s", format2, SZ_LINE)

	nrecs = 0

	check      = clgetb ("check")
	exclude    = clgetb ("exclude")
	decreasing = clgetb ("decreasing")

	if (decreasing && exclude) {

	    n1 = ceiling
	    for (n2 = n1 + 1; n2 > floor; n1 = n2 - 1) {

		if (get_previous_number (recs, n2) == EOF)
		    n2 = floor - 1
		else
		    n2 = max (n2, floor - 1)

		do num = n1, n2 + 1, -1 {
		    call nameout (format2, prepend, num, append, check)
		    nrecs = nrecs + 1
		}

	    }

	} else if (decreasing) {

	    for (num = maxi; num >= mini;
		junk = get_previous_number (recs, num)) {

		call nameout (format2, prepend, num, append, check)
		nrecs = nrecs + 1

	    }

	} else if (exclude) {

	    n1 = floor
	    for (n2 = n1 - 1; n2 < ceiling; n1 = n2 + 1) {

		if (get_next_number (recs, n2) == EOF)
		    n2 = ceiling + 1
		else
		    n2 = min (n2, ceiling + 1)

		do num = n1, n2 - 1 {
		    call nameout (format2, prepend, num, append, check)
		    nrecs = nrecs + 1
		}

	    }

	} else {

	    for (num = mini; num <= maxi;
		junk = get_next_number (recs, num)) {

		call nameout (format2, prepend, num, append, check)
		nrecs = nrecs + 1

	    }

	}

    call clputi ("number", nrecs)

    call flush (STDOUT)
end

# NAMEOUT - format and print each string with optional file checking

procedure nameout (format_string, prepend, number, append, check)

char	format_string
char	prepend
int	number
char	append
bool	check
char	name

int	access()

begin
	call sprintf (name, SZ_PATHNAME, format_string)
	    call pargstr (prepend)
	    call pargi   (number)
	    call pargstr (append)

	if (check)
	    if (access (name, 0, 0) == NO) return

	call printf ("%s\n")
	    call pargstr (name)
end
