include <imhdr.h>
include <error.h>

define	SIGNMASK	32767

procedure t_signfix ()

pointer	input, output, im1, im2, buf1, buf2, sp
int	npix, nlines, linenum
short	signmask

pointer	immap(), imgl2s(), impl2s()

errchk	immap

begin
	signmask = SIGNMASK

	call smark (sp)
	call salloc (input, SZ_FNAME, TY_CHAR)
	call salloc (output, SZ_FNAME, TY_CHAR)

	call clgstr ("input", Memc[input], SZ_FNAME)
	call clgstr ("output", Memc[output], SZ_FNAME)

	iferr (im1 = immap (Memc[input], READ_ONLY, 0))
	    call erract (EA_ERROR)

	if (IM_NDIM(im1) != 2) {
	    call eprintf ("only two dimensional images are supported")
	    call imunmap (im1)
	    call sfree (sp)
	    return
	}

	if (IM_PIXTYPE(im1) != TY_SHORT) {
	    call eprintf ("only short integer images are supported")
	    call imunmap (im1)
	    call sfree (sp)
	    return
	}

	iferr (im2 = immap (Memc[output], NEW_COPY, im1)) {
	    call imunmap (im1)
	    call sfree (sp)
	    call erract (EA_ERROR)
	}

	npix = IM_LEN(im1,1)
	nlines = IM_LEN(im1,2)

	do linenum = 1, nlines {
	    buf1 = imgl2s (im1, linenum)
	    buf2 = impl2s (im2, linenum)
	    call aandks (Mems[buf1], signmask, Mems[buf2], npix)
	}

	# Add a line to the history file (inherited from old image).
	call strcat ("New copy of ", IM_HISTORY(im2), SZ_IMHIST)
	call strcat (IM_HDRFILE(im1), IM_HISTORY(im2), SZ_IMHIST)
	call strcat (" with masked sign bit\n", IM_HISTORY(im2), SZ_IMHIST)

	call imunmap (im2)
	call imunmap (im1)
	call sfree (sp)
end
