procedure wdisplay (band)

string	band		{prompt="Wavelength band to display",
			    enum="vis|ir|wv|sa|all"}

bool	four	= no	{prompt="Display the last four images?"}
bool	old	= no	{prompt="Display old images?"}
bool	resize	= yes	{prompt="Select a larger frame buffer?"}
bool	verbose	= yes	{prompt="List the images displayed?"}
int	frame	= 1	{prompt="Frame buffer for displaying a single image"}

string	*list

begin
	string	mountain = "claret!/weather/"
	string	downtown = "gemini!/weather/"

	string	lband, archive, path, image, tmp1, tmp2
	int	lframe, ncount
	bool	reverse

	# an access() test on the directory is screwed due to the
	# fallback to the local machine if networking fails
	directory (mountain) | match ("no files found", stop-) |
	    count | scan (ncount)
	if (ncount == 0)
	    archive = mountain
	else {
	    directory (downtown) | match ("no files found", stop-) |
		count | scan (ncount)
	    if (ncount == 0)
		archive = downtown
	    else
		error (1, "Can't access the weather archive from this account")
	}

	lband = band

	if (verbose)
	    print ("accessing weather archive on `", archive, "'")

	if (resize) {
	    gdevices (devices="^imt", graphcap="graphcap") |
		match ("imtweather", stop-) | count | scan (ncount)
	    if (ncount > 0)
		set stdimage = imtweather
	    else
		set stdimage = imtfs35
	}

	if (lband == "all") {
	    if (verbose) {
		print ("\n Frame\t\t\t Image \t\t\t  UT \tdd/mm/yy")
		print (  " -----\t\t\t-------\t\t\t-----\t--------")
	    }
	    
	    dir (archive//"vis/*.imh", long-, ncols=1) |
		sort (num+, rev+) | head (nlines=1) | scan (image)
	    if (verbose) {
		printf ("   1\t")
		hselect (image, "$I,ut,date-obs", yes)
	    }
	    display (image, frame=1, erase+, fill-, select+,
		ztrans="none", xcenter=0.5, ycenter=0.5,
		xsize=1, ysize=1, xmag=1, ymag=1, >& "dev$null")

	    dir (archive//"ir/*.imh", long-, ncols=1) |
		sort (num+, rev+) | head (nlines=1) | scan (image)
	    if (verbose) {
		printf ("   2\t")
		hselect (image, "$I,ut,date-obs", yes)
	    }
	    display (image, frame=2, erase+, fill-, select+,
		ztrans="none", xcenter=0.5, ycenter=0.5,
		xsize=1, ysize=1, xmag=1, ymag=1, >& "dev$null")

	    dir (archive//"wv/*.imh", long-, ncols=1) |
		sort (num+, rev+) | head (nlines=1) | scan (image)
	    if (verbose) {
		printf ("   3\t")
		hselect (image, "$I,ut,date-obs", yes)
	    }
	    display (image, frame=3, erase+, fill-, select+,
		ztrans="none", xcenter=0.5, ycenter=0.5,
		xsize=1, ysize=1, xmag=1, ymag=1, >& "dev$null")

	    dir (archive//"sa/*.imh", long-, ncols=1) |
		sort (num+, rev+) | head (nlines=1) | scan (image)
	    if (verbose) {
		printf ("   4\t")
		hselect (image, "$I,ut,date-obs", yes)
	    }
	    display (image, frame=4, erase+, fill-, select+,
		ztrans="none", xcenter=0.5, ycenter=0.5,
		xsize=1, ysize=1, xmag=1, ymag=1, >& "dev$null")

	} else if (four) {
	    tmp1 = mktemp ("tmp$wdisp")
	    tmp2 = mktemp ("tmp$wdisp")

	    dir (archive//lband//"/*.imh", long-, ncols=1, > tmp1)

	    # 2 tmp files, rather than a pipe, since tail can't seek on STDIN
	    if (old)
		head (tmp1, nlines=4, > tmp2)
	    else
		tail (tmp1, nlines=4, > tmp2)

	    delete (tmp1, verify-, >& "dev$null")

	    if (verbose) {
		print ("\n Frame\t\t\t Image \t\t\t  UT \tdd/mm/yy")
		print (  " -----\t\t\t-------\t\t\t-----\t--------")
	    }

	    list = tmp2
	    for (lframe=1; fscan (list, image) != EOF; lframe+=1) {
		if (verbose) {
		    printf ("   %d\t", lframe)
		    hselect (image, "$I,ut,date-obs", yes)
		}

		display (image, frame=lframe, erase+, fill-, select+,
		    ztrans="none", xcenter=0.5, ycenter=0.5,
		    xsize=1, ysize=1, xmag=1, ymag=1, >& "dev$null")
	    }

	    list = ""; delete (tmp2, verify-, >& "dev$null")

	} else {
	    reverse = ! old
	    dir (archive//lband//"/*.imh", long-, ncols=1) |
		sort (num+, rev=reverse) | head (nlines=1) | scan (image)

	    if (verbose) {
		print ("\n Frame\t\t\t Image \t\t\t  UT \tdd/mm/yy")
		print (  " -----\t\t\t-------\t\t\t-----\t--------")
		printf ("   %d\t", frame)
		hselect (image, "$I,ut,date-obs", yes)
	    }

	    display (image, frame=frame, erase+, fill-, select+,
		ztrans="none", xcenter=0.5, ycenter=0.5,
		xsize=1, ysize=1, xmag=1, ymag=1, >& "dev$null")
	}

	printf ("\n")
end
