C     SUBROUTINE NUMBER1
C
C     PURPOSE
C        TO PLOT A REAL NUMBER CENTERED ON COORDINATED X-Y
C
C     USAGE
C        CALL NUMBER1(X,Y,HT,FNUM,THETA,IDEC)
C          X      - X COORDINATE IN INCHES
C          Y      - Y COORDINATE IN INCHES
C          HT     - HEIGHT AT WHICH THE NUMBER IS TO BE PLOTTED
C          FPN    - FLOATING POINT NUMBER TO BE PLOTTED
C          THETA  - ANGLE AT WHICH NUMBER IS TO BE PLOTTED
C          IDEC   - NUMBER OF DECIMAL PLACES TO BE DRAWN.
C
C     SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED
C        SYMBOL - SUBROUTINE TO PLOT A SYMBOL OR CHARACTER STRING
C
C     COMMENTS
C        THIS PROGRAM WAS CONSTRUCTED BY ED ANDERSON, NOAO, AUGUST 1985,
C         BASED ON ORIGINAL ROUTINE "NUMBER".
C
CALCOMP  PRODUCT NUMBER  411010*2-G              EBCDIC PUNCH
CALCOMP HCBS FOR CDC-6000     906/EM RS-232 ONLINE          JUL, 1979 *
CALCOMP  COPYRIGHT 1979 CALIFORNIA COMPUTER PRODUCTS INC.
C
      SUBROUTINE NUMBER1(XPAGE,YPAGE,HEIGHT,FPN,ANGLE,NDEC)
      DIMENSION NUM(20)
      MINUS =ICHAR('-')
      IZERO =ICHAR('0')
      IPOINT=ICHAR('.')
      PI=4.*ATAN(1.)
      STH=SIN(ANGLE*PI/180.)
      CTH=COS(ANGLE*PI/180.)
      II=0
      FPV = FPN
      N = NDEC
      MAXN = 9
      IF (N - MAXN) 11, 11, 10
   10 N = MAXN
   11 IF (N + MAXN) 12, 20, 20
   12 N = -MAXN
   20 IF (FPV) 21, 30, 30
21    II=II+1
      NUM(II)=MINUS
   30 MN = -N
      IF (N) 31, 32, 32
   31 MN = MN - 1
   32 FPV = ABS(FPV) + (0.5 * 10. ** MN)
      I = ALOG10(FPV)+1.0
      ILP = I
      IF (N + 1)  40, 41, 41
   40 ILP = ILP + N + 1
   41 IF (ILP)  50, 50, 51
50    II=II+1
      NUM(II)=IZERO
      GO TO 61
51    IF (ILP+N-18) 54,54,52
52    N=-1
      IF (ILP-19) 54,54,53
53    ILP=19
54    DO 60 J=1,ILP
        K = FPV * 10. ** (J - I)
      IF (K-9) 57,57,55
   55   K = 9
   57 II=II+1
      NUM(II)=K+IZERO
        FPV = FPV - (FLOAT(K) * 10. ** (I - J))
60    CONTINUE
   61 IF (N) 99, 70, 70
70    II=II+1
      NUM(II)=IPOINT
      IF (N)  99, 99, 80
   80 DO 90 J = 1, N
        K = FPV * 10.
      IF (K-9) 84,84,82
   82   K = 9
   84 II=II+1
      NUM(II)=K+IZERO
   90   FPV = FPV * 10. - FLOAT(K)
99    WLEN=FLOAT(II)*6./7.*HEIGHT
      XPOS=XPAGE-(WLEN/2.*CTH)
      YPOS=YPAGE-(WLEN/2.*STH)
      CALL SYMBOL (XPOS,YPOS,HEIGHT,NUM,ANGLE,II+1000)
      RETURN
      END
